//=============================================================================
// CASIO Mobile Device CameraLib Sample                                       +
// Copyright (C) 2005 CASIO COMPUTER CO., LTD. All Rights Reserved.           +
//=============================================================================
// main.c                                                        +
//-----------------------------------------------------------------------------
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "resource.h"

#define MAX_LOADSTRING 100

// Global variable
HINSTANCE			hInst;			// Instance
HWND				hDlg;			// DialogBox handle

BOOL				InitInstance		(HINSTANCE, int);
ATOM				MyRegisterClass		(HINSTANCE, LPTSTR);
LRESULT CALLBACK	WndProc				(HWND, UINT, WPARAM, LPARAM);

extern LRESULT CALLBACK DlgProc			(HWND, UINT, WPARAM, LPARAM);


// Application entry point
int WINAPI WinMain(	HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	if(!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	// Message loop
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if(!IsDialogMessage(hDlg, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;
	TCHAR	szTitle[MAX_LOADSTRING];
	TCHAR	szClass[MAX_LOADSTRING];

	hInst = hInstance;

	// Register a Window Class.
	LoadString(hInstance, IDS_WND_CLASS, szClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance, szClass);

	// Make a main window.
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	hWnd = CreateWindowEx(WS_EX_WINDOWEDGE, szClass, szTitle, WS_CAPTION | WS_SYSMENU | WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInstance, NULL);
	if(!hWnd)
	{
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}


ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szClass)
{
	WNDCLASS	wc;

	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC) WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= NULL;
	wc.hCursor			= 0;
	wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName		= 0;
	wc.lpszClassName	= szClass;

	return RegisterClass(&wc);
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_CREATE:
		// Make a DialogBox.
		hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, (DLGPROC)DlgProc);
		if(hDlg == NULL)
		{
			return -1;
		}
		break;

	case WM_CLOSE:
		// Close Window
		SendMessage(hDlg, WM_CLOSE, 0, 0);
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
