'***************************************************************************
'* <Description>
'* Form1.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* Camera Capture Demo program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target>
'* DT-5300 WM / IT-800 WM model
'* -------------------------------------------------------------------------
'* Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2010.02.24      CASIO       000000      Original      
'* 
'***************************************************************************/

Imports Calib.CameraLibNet.Api
Imports Calib.CameraLibNet.Def

Public Class Form1
    Public Declare Function GetForegroundWindow Lib "Coredll" () As IntPtr
    Dim iRet As Integer

    Dim iImgSize As Integer
    Dim nImgSize() As Integer = {CAM_UXGA, _
                                CAM_QUADVGA, _
                                CAM_XGA, _
                                CAM_SVGA, _
                                CAM_VGA, _
                                CAM_QVGA}

    Dim iLightList As Integer
    Dim nLightList() As Integer = {CAM_LIGHT_AUTO, _
                                    CAM_OUTDOOR, _
                                    CAM_FLUORESCENT, _
                                    CAM_INCANDESCE, _
                                    16} 'CAM_DIMLIGHT

    Dim iFlashList As Integer
    Dim nFlashList() As Integer = {CAM_FLASH_ENABLE, _
                                    CAM_FLASH_DISABLE}

    Dim bLEDList As Boolean
    Dim nLEDList() As Boolean = {False, True}

    Private Sub Form1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.GotFocus
        Dim hwnd As IntPtr
        Dim i As Integer

        iRet = CAMOpen()

        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMOpen...OK"
        Application.DoEvents()


        iRet = CAMSetIllumination(0)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMSetIllumination...OK"
        Application.DoEvents()

        hwnd = GetForegroundWindow()

        iRet = CAMStartPreview(hwnd, 120, 10, CAM_QVGA)

        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMStartPreview...OK"
        Application.DoEvents()

        ComboBox1.SelectedIndex = 3     ' SVGA
        ComboBox3.SelectedIndex = 0     ' AUTO
        ComboBox2.SelectedIndex = 0     ' LED Flash No
        ComboBox5.SelectedIndex = 0     ' LED OFF

        iImgSize = nImgSize(ComboBox1.SelectedIndex)

        For i = 0 To 100
            ComboBox4.Items.Add((i).ToString)
        Next
        ComboBox4.SelectedIndex = 50    ' 50

        iRet = CAMIlluminationOn(False)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMIlluminationOn...OK"
        Application.DoEvents()

        iRet = CAMSetPreviewMode(CAM_PREVIEW_FOCUSFRAME, 0)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMSetPreviewMode...OK"
        Application.DoEvents()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        CAMIlluminationOn(False)
        CAMClose()
        Me.Close()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim str As String

        str = "\My Documents\Image"
        str = str + Format(Now.Date, "yy") + Format(Now.Date, "MM") + Format(Now.Date, "dd") + "_" + Format(Now, "HH") + Format(Now, "mm") + Format(Now, "ss")
        str = str + ".jpg"

        iRet = CAMSingleCapture(str, Calib.CameraLibNet.Def.CAM_JPEG, iImgSize)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMSingleCapture...OK"
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        iImgSize = nImgSize(ComboBox1.SelectedIndex)
    End Sub

    Private Sub ComboBox3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox3.SelectedIndexChanged
        iLightList = nLightList(ComboBox3.SelectedIndex)

        iRet = CAMSetLightMode(iLightList)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMSetLightMode...OK"
    End Sub

    Private Sub ComboBox4_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox4.SelectedIndexChanged
        iRet = CAMSetIllumination(ComboBox4.SelectedIndex)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMSetIllumination...OK"
    End Sub

    Function DispErrorMessage(ByVal iRet As Integer) As Boolean
        Select Case iRet
            Case CAM_NOTOPENED
                StatusBar1.Text = "CAM_NOTOPENED"
            Case CAM_INVALID_PARAM
                StatusBar1.Text = "CAM_INVALID_PARAM"
            Case CAM_INTERNAL_ERROR
                StatusBar1.Text = "CAM_INTERNAL_ERROR"
            Case FUNCTION_UNSUPPORT
                StatusBar1.Text = "FUNCTION_UNSUPPORT"
            Case CAM_NOTOPENED
                StatusBar1.Text = "CAM_NOTOPENED"
            Case CAM_INVALID_PARAM
                StatusBar1.Text = "CAM_INVALID_PARAM"
            Case CAM_NOT_STARTED
                StatusBar1.Text = "CAM_NOT_STARTED"
            Case CAM_FILE_ERROR
                StatusBar1.Text = "CAM_FILE_ERROR"
            Case CAM_INTERNAL_ERROR
                StatusBar1.Text = "CAM_INTERNAL_ERROR"
            Case CAM_NOT_ENOUGH_MEMORY
                StatusBar1.Text = "CAM_NOT_ENOUGH_MEMORY"
            Case CAM_NOTOPENED
                StatusBar1.Text = "CAM_NOTOPENED"
            Case CAM_INVALID_PARAM
                StatusBar1.Text = "CAM_INVALID_PARAM"
            Case CAM_INTERNAL_ERROR
                StatusBar1.Text = "CAM_INTERNAL_ERROR"
            Case CAM_NOTOPENED
                StatusBar1.Text = "CAM_NOTOPENED"
            Case CAM_OPENERROR
                StatusBar1.Text = "CAM_OPENERROR"
            Case CAM_INVALID_PARAM
                StatusBar1.Text = "CAM_INVALID_PARAM"
            Case CAM_SHOW_ERROR
                StatusBar1.Text = "CAM_SHOW_ERROR"
            Case CAM_INTERNAL_ERROR
                StatusBar1.Text = "CAM_INTERNAL_ERROR"
            Case CAM_NOT_ENOUGH_MEMORY
                StatusBar1.Text = "CAM_NOT_ENOUGH_MEMORY"
            Case CAM_INVALID_ACCESS
                StatusBar1.Text = "CAM_INVALID_ACCESS"
            Case FUNCTION_UNSUPPORT
                StatusBar1.Text = "FUNCTION_UNSUPPORT"

            Case Else
                StatusBar1.Text = "Other error"
        End Select
    End Function

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        iRet = CAMAutoFocus(CAM_AF_NORMAL, 0)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMAutoFocus...OK"
        Application.DoEvents()
    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
        iFlashList = nFlashList(ComboBox2.SelectedIndex)

        iRet = CAMSetFlash(iFlashList, 0)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMSetFlash...OK"
    End Sub

    Private Sub ComboBox5_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox5.SelectedIndexChanged
        bLEDList = nLEDList(ComboBox5.SelectedIndex)

        iRet = CAMIlluminationOn(bLEDList)
        If iRet <> CAM_SUCCESS Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        StatusBar1.Text = "CAMIlluminationOn...OK"
        Application.DoEvents()
    End Sub
End Class
