/***************************************************************************
 * <Description>
 * FLINKLibSampleWMVC.cpp (Casio Computer Co., Ltd.)
 * -------------------------------------------------------------------------
 * <Function outline>
 * FLINK Library Demo program
 * -------------------------------------------------------------------------
 * <Language>
 * Visual C++
 * -------------------------------------------------------------------------
 * <Develop Environment>
 * VS 2005
 * -------------------------------------------------------------------------
 * <Target>
 * DT-5300 WM / IT-800 WM / IT-300 model
 * -------------------------------------------------------------------------
 * Copyright(C)2009 CASIO COMPUTER CO.,LTD. All rights reserved.
 * -------------------------------------------------------------------------
 * <History>
 * Version  Date            Company     Keyword     Comment
 * 1.0.0    2010.05.12      CASIO       000000      Original      
 * 
 ***************************************************************************/
//	000000__	Original
//	__000000	Original

#include <windows.h>
#include "resource.h"
#include <aygshell.h>

//	000000__	Original
//  CASIO Libaray
#include "SystemLib.h"
#include "FlinkLib.h"
//	__000000	Original

#define MAX_LOADSTRING 100
HINSTANCE				hInst;			// current instance

HANDLE m_port;

BOOL DlgMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
//BOOL NFC_Scan(HWND hDlg);
//BOOL DispErrorMessage(HWND hDlg, int iRet);
//extern LRESULT CALLBACK	LedDlgProc			(HWND, UINT, WPARAM, LPARAM);
//extern LRESULT CALLBACK	BuzzerDlgProc		(HWND, UINT, WPARAM, LPARAM);
//extern LRESULT CALLBACK VibratorDlgProc		(HWND, UINT, WPARAM, LPARAM);

int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPWSTR lpCmdLine, int nShowCmd)
{
	hInst = hInstance;
	DialogBoxW(hInstance, MAKEINTRESOURCE( IDD_MAIN ), NULL, DlgMain);
	return 0;
}

BOOL DlgMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	DWORD	ret;
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			RECT rc;
			#define MENU_HEIGHT 26

            // Create a Done button and size it.  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_SIPDOWN | SHIDIF_FULLSCREENNOMENUBAR ;
            shidi.hDlg = hDlg;
            SHInitDialog(&shidi);
				
			GetWindowRect(hDlg, &rc);
			MoveWindow(hDlg, rc.left, rc.top, rc.right, rc.bottom+MENU_HEIGHT, TRUE);

			SetForegroundWindow(hDlg);
			SHFullScreen(hDlg, SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);	

			//HMENU hMenu;

			//hMenu = LoadMenu(  hInst, MAKEINTRESOURCE(IDR_MENU1));

			//SHMENUBARINFO mbi = {0};
			//mbi.cbSize = sizeof(SHMENUBARINFO);
			//mbi.hwndParent = hDlg;
			//mbi.dwFlags = SHCMBF_HMENU;
			//mbi.nToolBarId = (UINT)hMenu;
			//mbi.hInstRes =  hInst;

			//if (!SHCreateMenuBar(&mbi)){
			//	MessageBox(hDlg,L"failed", L"Error",MB_OK | MB_ICONERROR);
			//}



		}
		//ShowWindow(GetDlgItem( hDlg, IDC_IC_CARD), SW_HIDE);
        return (INT_PTR)TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_EXIT:
			EndDialog(hDlg, LOWORD(wParam));
			break;
		case IDC_OPEN:
			char		ipadr[100];
			FLK_RSPRM	rsprm;
			m_port = FLKOpen(_T("USB"), ipadr, &rsprm, FLK_MODE_HT, NULL, 0);
			if ((m_port == (HANDLE)FLK_NG) || (m_port == (HANDLE)FLK_PRM))
			{
				MessageBox(NULL, _T("FLKOpen Error0"),_T("FLKOpen Error1"), 0);
				break;
			}
			SetTimer(hDlg, ID_MYTIMER, 100, NULL);
			break;
		case IDC_IDLE:
			//DWORD	ret;
			ret = FLKIdle(m_port, NULL);
			if (ret != FLK_OK)
			{
				MessageBox(hDlg, _T("FLKIdel Error"), _T("FLKIdle Error"), 0);
				break;
			}
			SetTimer(hDlg, ID_MYTIMER, 100, NULL);
			break;
		case IDC_RECEIVE:
			//DWORD	ret;

			ret = FLKFileRecv(m_port, FLK_TRANS_NORMAL, _T("C:\\temp\\*.*"), _T("\\temp\\"), FLK_PROTECT_VALID);
			if (ret != FLK_OK)
			{
				MessageBox(hDlg, _T("FLKReceiveFile Error"), _T("FLKReceiveFile"), 0);
				break;
			}
			SetTimer(hDlg, ID_MYTIMER, 100, NULL);
			break;
		case IDC_SEND:
			//DWORD	ret;

			ret = FLKFileSend(m_port, FLK_TRANS_NORMAL, _T("\\temp\\*.*"), _T("C:\\temp\\"), FLK_PROTECT_VALID);
			if (ret != FLK_OK)
			{
				MessageBox(hDlg, _T("FLKSendFile Error"), _T("FLKSendFile"),0);
				break;
			}
			SetTimer(hDlg, ID_MYTIMER, 100, NULL);
			break;


		case IDC_DISCONNECT:
			FLKClose(m_port, FLK_CLOSE_NORMAL);
			break;
			
		

		//case IDM_LED:
		//	DialogBox(hInst, MAKEINTRESOURCE(IDD_LED), hDlg, (DLGPROC)LedDlgProc);
		//	break;
		//case IDM_BUZZER:
		//	DialogBox(hInst, MAKEINTRESOURCE(IDD_BUZZER), hDlg, (DLGPROC)BuzzerDlgProc);
		//	break;
		//case IDM_VIBRATOR:
		//	DialogBox(hInst, MAKEINTRESOURCE(IDD_VIBRATOR), hDlg, (DLGPROC)VibratorDlgProc);
		//	break;

		//case IDC_NFC_SCAN:
		//	NFC_Scan(hDlg);
		//	break;
		}
		break;
	case WM_TIMER:
		FLK_STATUS flkstatus;
		KillTimer(hDlg, ID_MYTIMER);

		FLKReadStatus(m_port, &flkstatus);
		if (flkstatus.status == FLK_STATUS_ERROR)
		{
			MessageBox(hDlg, _T("Command Error"), _T("Commond Error"), 0);
			break;
		}
		if (flkstatus.status == FLK_STATUS_END)
		{
			MessageBox(hDlg, _T("Command complete"), _T("Command complete"), 0);
			break;
		}

		SetWindowText(GetDlgItem(hDlg, IDC_FILENAME), flkstatus.FileName);

		if (flkstatus.file_size != 0)
		{
			SendMessage(GetDlgItem(hDlg, IDC_PROGRESS1),PBM_SETPOS, 
				flkstatus.file_count*100/flkstatus.file_size, 0);
			SendMessage(GetDlgItem(hDlg, IDC_PROGRESS2),PBM_SETPOS, 
				flkstatus.total_count * 100 / flkstatus.total_size, 0);


		}



		SetTimer(hDlg, ID_MYTIMER, 100, NULL);

		break;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		break;
	}
	return FALSE;
}

//// error message display
//void ShowErrorMessage(HWND hWnd, LPCTSTR pszCaption, DWORD dwStatus)
//{
//	TCHAR szTitle[MAX_LOADSTRING];
//	TCHAR szMsg[MAX_LOADSTRING];
//	UINT idError;
//
//	// message box caption
//	if(pszCaption && wcslen(pszCaption))
//	{
//		wcscpy(szTitle, pszCaption);
//	}
//	else
//	{
//		LoadString(hInst, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
//	}
//
//	//error message
//	if(dwStatus == SYS_PARAMERR)			idError = IDS_ERR_PARAMETER;
//	else if(dwStatus == FUNCTION_UNSUPPORT)	idError = IDS_ERR_UNSUPPORT;
//	else									return;
//
//	// message box display
//	LoadString(hInst, idError, szMsg, MAX_LOADSTRING);
//	MessageBox(hWnd, szMsg, szTitle, MB_OK | MB_ICONSTOP);
//}
