Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports Calib

Public Class Form1

    ' Gesture define
    Private Const WM_GESTURE As UInteger = &H119
    Private Const GID_BEGIN As UInteger = 1
    Private Const GID_END As UInteger = 2
    Private Const GID_PAN As UInteger = 4
    Private Const GID_TWOFINGERTAP As UInteger = 6
    Private Const GID_PRESSANDTAP As UInteger = 7
    Private Const GID_SCROLL As UInteger = 8
    Private Const GID_HOLD As UInteger = 9
    Private Const GID_SELECT As UInteger = 10
    Private Const GID_DOUBLESELECT As UInteger = 11
    Private Const GID_LAST As UInteger = 11

    <DllImport("coredll.dll")> _
Private Shared Function GetGestureInfo(ByVal hGestureInfo As IntPtr, ByRef pGestureInfo As GESTUREINFO) As Boolean
    End Function
    Private Delegate Function WndProcDelegate(ByVal hwnd As IntPtr, ByVal msg As UInteger, ByVal wParam As UInteger, ByVal lParam As Integer) As Integer
    Private wndProc As WndProcDelegate
    Private wndProcPtr As IntPtr
    Private oldProcPtr As IntPtr

    <DllImport("coredll.dll")> _
Private Shared Function SetWindowLong(ByVal hwnd As IntPtr, ByVal nIndex As Integer, ByVal dwNewLong As IntPtr) As IntPtr
    End Function
    Private Const GWL_WNDPROC As Integer = -4

    <DllImport("coredll.dll")> _
    Public Shared Function CallWindowProc(ByVal lpPrevWndFunc As IntPtr, ByVal hwnd As IntPtr, ByVal msg As UInteger, ByVal wParam As UInteger, ByVal lParam As Integer) As Integer
    End Function

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure GESTUREINFO
        Public cbSize As Integer
        Public dwFlags As Integer
        Public dwID As Integer
        Public hwndTarget As IntPtr
        <MarshalAs(UnmanagedType.Struct)> _
        Public ptsLocation As POINTS
        Public dwInstanceID As Integer
        Public dwSequenceID As Integer
        Public ullArguments As UInt64
        Public cbExtraArgs As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure POINTS
        Public x As Short
        Public y As Short
    End Structure


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If True Then
            wndProc = New WndProcDelegate(AddressOf WndProc1)
            wndProcPtr = Marshal.GetFunctionPointerForDelegate(wndProc)
            oldProcPtr = SetWindowLong(Me.Handle, GWL_WNDPROC, wndProcPtr)
        End If

    End Sub

    Protected Overridable Function WndProc1(ByVal hwnd As IntPtr, ByVal msg As UInteger, ByVal wParam As UInteger, ByVal lParam As Integer) As Integer
        Dim iDistance As Int32 = 0
        Dim iAngle As Int32 = 0

        Select Case msg
            Case WM_GESTURE
                Calib.SystemLibNet.Api.SysConvertGestureMessage(msg, wParam, lParam, iDistance, iAngle)
                Return OnGesture(hwnd, wParam, lParam, iDistance, iAngle)
        End Select
        Return CallWindowProc(oldProcPtr, hwnd, msg, wParam, lParam)


    End Function

    Private Function OnGesture(ByVal hwnd As IntPtr, ByVal wParam As UInteger, ByVal lParam As Integer, ByVal iDistance As Int32, ByVal iAngle As Int32) As Int32
        Dim gi As New GESTUREINFO()
        gi.cbSize = Marshal.SizeOf(GetType(GESTUREINFO))
        Dim bRet As Boolean = GetGestureInfo(lParam, gi)
        Dim strGestureMessage As String = ""

        If bRet Then
            Select Case wParam
                Case GID_BEGIN, GID_END
                    Exit Select

                Case GID_PAN
                    strGestureMessage = "GID_PAN" & vbLf & "X: " & gi.ptsLocation.x.ToString() & ", Y: " & gi.ptsLocation.y.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select

                Case GID_SCROLL
                    strGestureMessage = "GID_SCROLL" & vbLf & "X: " & gi.ptsLocation.x.ToString() & ", Y: " & gi.ptsLocation.y.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select

                Case GID_HOLD
                    strGestureMessage = "GID_HOLD" & vbLf & "X: " & gi.ptsLocation.x.ToString() & ", Y: " & gi.ptsLocation.y.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select

                Case GID_SELECT
                    strGestureMessage = "GID_SELECT" & vbLf & "X: " & gi.ptsLocation.x.ToString() & ", Y: " & gi.ptsLocation.y.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select

                Case GID_DOUBLESELECT
                    strGestureMessage = "GID_DOUBLESELECT" & vbLf & "X: " & gi.ptsLocation.x.ToString() & ", Y: " & gi.ptsLocation.y.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select

                Case Calib.SystemLibNet.Def.GID_ROTATE
                    strGestureMessage = "GID_ROTATE" & vbLf & "Angle: " & iAngle.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select

                Case Calib.SystemLibNet.Def.GID_ZOOM
                    strGestureMessage = "GID_ZOOM" & vbLf & "Distance: " & iDistance.ToString()
                    labelGesture.Text = strGestureMessage
                    Exit Select
            End Select
        End If
        Return CallWindowProc(oldProcPtr, hwnd, WM_GESTURE, wParam, lParam)
    End Function


    Private Sub menuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuExit.Click
        Application.Exit()
    End Sub
End Class
