#include "stdafx.h"
#include "MCReadLibSampleVC.h"
#include <windows.h>
#include <commctrl.h>
#include <MCReadLib.h>

#define MAX_LOADSTRING 100

HINSTANCE			g_hInst;
#ifdef SHELL_AYGSHELL
HWND				g_hWndMenuBar;
#else // SHELL_AYGSHELL
HWND				g_hWndCommandBar;
#endif // SHELL_AYGSHELL

ATOM				MyRegisterClass(HINSTANCE, LPTSTR);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

HWND g_hEditISO1, g_hEditISO2, g_hEditISO3;
void InitMcr( void);
void DeinitMcr( void);
void ReadMcrData( void);

int WINAPI WinMain(HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;

	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MCRSAMPLE));

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MCRSAMPLE));
	wc.hCursor       = 0;
#ifdef SHELL_AYGSHELL
	wc.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH);
#else
	wc.hbrBackground = (HBRUSH) GetStockObject( LTGRAY_BRUSH);
#endif	// SHELL_AYGSHELL
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
	TCHAR szTitle[MAX_LOADSTRING];
	TCHAR szWindowClass[MAX_LOADSTRING];

	g_hInst = hInstance;

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
	SHInitExtraControls();
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
	LoadString(hInstance, IDC_MCRSAMPLE, szWindowClass, MAX_LOADSTRING);

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP

	if (!MyRegisterClass(hInstance, szWindowClass))
	{
		return FALSE;
	}

	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}

#ifdef WIN32_PLATFORM_PSPC
	if (g_hWndMenuBar)
	{
		RECT rc;
		RECT rcMenuBar;

		GetWindowRect(hWnd, &rc);
		GetWindowRect(g_hWndMenuBar, &rcMenuBar);
		rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);

		MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
	}
#endif // WIN32_PLATFORM_PSPC

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

#ifndef SHELL_AYGSHELL
	if (g_hWndCommandBar)
	{
		CommandBar_Show(g_hWndCommandBar, TRUE);
	}
#endif // !SHELL_AYGSHELL

	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
	static SHACTIVATEINFO s_sai;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		switch (wmId)
		{
		case IDM_HELP_ABOUT:
			DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
			break;
#ifndef SHELL_AYGSHELL
		case IDM_FILE_EXIT:
			DestroyWindow(hWnd);
			break;
#endif // !SHELL_AYGSHELL
#ifdef WIN32_PLATFORM_PSPC
		case IDM_OK:
			SendMessage (hWnd, WM_CLOSE, 0, 0);
			break;
#endif // WIN32_PLATFORM_PSPC
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_CREATE:
#ifndef SHELL_AYGSHELL
		g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
		CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
		CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		SHMENUBARINFO mbi;

		memset(&mbi, 0, sizeof(SHMENUBARINFO));
		mbi.cbSize     = sizeof(SHMENUBARINFO);
		mbi.hwndParent = hWnd;
		mbi.nToolBarId = IDR_MENU;
		mbi.hInstRes   = g_hInst;

		if (!SHCreateMenuBar(&mbi)) 
		{
			g_hWndMenuBar = NULL;
		}
		else
		{
			g_hWndMenuBar = mbi.hwndMB;
		}

		memset(&s_sai, 0, sizeof (s_sai));
		s_sai.cbSize = sizeof (s_sai);
#endif // SHELL_AYGSHELL

		TCHAR szMes[ 128];
		if ( LOWORD( GetKeyboardLayout( 0)) == 0x0411)
		{
			wcscpy( szMes, _T("CJ[hXChĂB"));
		}
		else
		{
			wcscpy( szMes, _T("Please read the magnetic card."));
		}

#ifdef SHELL_AYGSHELL
		CreateWindow( _T("static"), szMes, WS_CHILD | WS_VISIBLE,
			40,  20, 400,  40, hWnd, NULL, g_hInst, NULL);
		CreateWindow( _T("static"), L"Track1", WS_CHILD | WS_VISIBLE,
			40,  60, 120,  40, hWnd, NULL, g_hInst, NULL);
		g_hEditISO1 = CreateWindow(_T("EDIT"), NULL,
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | WS_VSCROLL | ES_MULTILINE,
			40, 100, 400, 100, hWnd, NULL, g_hInst, NULL);
		CreateWindow( _T("static"), L"Track2", WS_CHILD | WS_VISIBLE,
			40, 210, 120,  40, hWnd, NULL, g_hInst, NULL);
		g_hEditISO2 = CreateWindow(_T("EDIT"), NULL,
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | WS_VSCROLL | ES_MULTILINE,
			40, 250, 400, 100, hWnd, NULL, g_hInst, NULL);
		CreateWindow( _T("static"), L"Track3", WS_CHILD | WS_VISIBLE,
			40, 360, 120,  40, hWnd, NULL, g_hInst, NULL);
		g_hEditISO3 = CreateWindow(_T("EDIT"), NULL,
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | WS_VSCROLL | ES_MULTILINE,
			40, 400, 400, 100, hWnd, NULL, g_hInst, NULL);
#else
		CreateWindow( _T("static"), szMes, WS_CHILD | WS_VISIBLE,
			20,  30, 200,  20, hWnd, NULL, g_hInst, NULL);
		CreateWindow( _T("static"), L"Track1", WS_CHILD | WS_VISIBLE,
			20,  50,  60,  20, hWnd, NULL, g_hInst, NULL);
		g_hEditISO1 = CreateWindow(_T("EDIT"), NULL,
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | WS_VSCROLL | ES_MULTILINE,
			20,  70, 200, 48, hWnd, NULL, g_hInst, NULL);
		CreateWindow( _T("static"), L"Track2", WS_CHILD | WS_VISIBLE,
			20, 130,  60,  20, hWnd, NULL, g_hInst, NULL);
		g_hEditISO2 = CreateWindow(_T("EDIT"), NULL,
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | WS_VSCROLL | ES_MULTILINE,
			20, 150, 200, 48, hWnd, NULL, g_hInst, NULL);
		CreateWindow( _T("static"), L"Track3", WS_CHILD | WS_VISIBLE,
			20, 210,  60,  20, hWnd, NULL, g_hInst, NULL);
		g_hEditISO3 = CreateWindow(_T("EDIT"), NULL,
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT | WS_VSCROLL | ES_MULTILINE,
			20, 230, 200, 48, hWnd, NULL, g_hInst, NULL);
#endif // SHELL_AYGSHELL

		InitMcr();

		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);

		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		DeinitMcr();

#ifndef SHELL_AYGSHELL
		CommandBar_Destroy(g_hWndCommandBar);
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		CommandBar_Destroy(g_hWndMenuBar);
#endif // SHELL_AYGSHELL
		PostQuitMessage(0);
		break;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
	case WM_ACTIVATE:
		SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
		break;
	case WM_SETTINGCHANGE:
		SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
		break;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

	case WM_MCR_READING:
		ReadMcrData();
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
#ifndef SHELL_AYGSHELL
		RECT rectChild, rectParent;
		int DlgWidth, DlgHeight;
		int NewPosX, NewPosY;

		if (GetWindowRect(hDlg, &rectChild)) 
		{
			GetClientRect(GetParent(hDlg), &rectParent);
			DlgWidth	= rectChild.right - rectChild.left;
			DlgHeight	= rectChild.bottom - rectChild.top ;
			NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
			NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;

			if (NewPosX < 0) NewPosX = 0;
			if (NewPosY < 0) NewPosY = 0;
			SetWindowPos(hDlg, 0, NewPosX, NewPosY,
				0, 0, SWP_NOZORDER | SWP_NOSIZE);
		}
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		{
			SHINITDLGINFO shidi;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
		}
#endif // SHELL_AYGSHELL

		return (INT_PTR)TRUE;

	case WM_COMMAND:
#ifndef SHELL_AYGSHELL
		if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		if (LOWORD(wParam) == IDOK)
#endif
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;

	case WM_CLOSE:
		EndDialog(hDlg, message);
		return (INT_PTR)TRUE;

	}
	return (INT_PTR)FALSE;
}

void MakeDispStr( UCHAR *, int, TCHAR *, int);

void InitMcr( void)
{
	MCROpen( NULL);
	MCRSetEventNotification( FALSE);
}

void DeinitMcr( void)
{
	MCRClose();
}

void ReadMcrData( void)
{
	unsigned char pDataISO1[ 128], pDataISO2[ 128], pDataISO3[ 128];
	int nStatISO1, nStatISO2, nStatISO3;
	TCHAR szDispStr[ 1024];

	MCRRead( NULL, pDataISO1, pDataISO2, pDataISO3, NULL, &nStatISO1, &nStatISO2, &nStatISO3);

	if ( nStatISO1 == MCR_DATA_SUCCESS)
	{
		MakeDispStr( pDataISO1, sizeof( pDataISO1), szDispStr, sizeof( szDispStr));
		SetWindowText( g_hEditISO1, szDispStr);
	}
	else
	{
		SetWindowText( g_hEditISO1, NULL);
	}

	if ( nStatISO2 == MCR_DATA_SUCCESS)
	{
		MakeDispStr( pDataISO2, sizeof( pDataISO2), szDispStr, sizeof( szDispStr));
		SetWindowText( g_hEditISO2, szDispStr);
	}
	else
	{
		SetWindowText( g_hEditISO2, NULL);
	}

	if ( nStatISO3 == MCR_DATA_SUCCESS)
	{
		MakeDispStr( pDataISO3, sizeof( pDataISO3), szDispStr, sizeof( szDispStr));
		SetWindowText( g_hEditISO3, szDispStr);
	}
	else
	{
		SetWindowText( g_hEditISO3, NULL);
	}
}

void MakeDispStr( UCHAR *pSrcData, int nLen, TCHAR *pOutData, int nOutLen)
{
	int i;
	TCHAR szBuff[ 256];

	ZeroMemory( pOutData, nOutLen);
	for ( i = 0; i < nLen; i++)
	{
		wsprintf( szBuff, _T("%02X "), *(pSrcData+i));
		wcscat( pOutData, szBuff);
	}
}
