/******************************************************************************
*  MoSpkSampleVCDlg.cpp                                                       *
*                                                                             *
*  Project : MoSpk Demo Application                                           *
*                                                                             *
*  Copyright (C) 2007, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
******************************************************************************/
#include "stdafx.h"
#include "MoSpkSampleVC.h"
#include "MoSpkSampleVCDlg.h"
#include "OBReadLib.h"
#include "MoSpk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// e탌OX
#define SCANCODE_MAX_LEN	1024
#define SPEAK_MAX_LEN		3

/////////////////////////////////////////////////////////////////////////////
// CMoSpkSampleVCDlg _CAO

CMoSpkSampleVCDlg::CMoSpkSampleVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMoSpkSampleVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMoSpkSampleVCDlg)

	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// 䃉Cũnh܂B
	m_hDevice = NULL;

	// OBRI[vmFptO܂B
	m_bOBROpen = FALSE;
}

CMoSpkSampleVCDlg::~CMoSpkSampleVCDlg()
{
	// OBRN[Y܂B
	if( m_bOBROpen != FALSE )
	{
		OBRClose();
	}

	// 䃉CuN[Y܂B
	if( m_hDevice != NULL )
	{
		MoSpk_Close( m_hDevice );
	}
}

void CMoSpkSampleVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMoSpkSampleVCDlg)

	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMoSpkSampleVCDlg, CDialog)
	//{{AFX_MSG_MAP(CMoSpkSampleVCDlg)
	ON_BN_CLICKED(IDC_SPEAK, OnSpeak)
	ON_MESSAGE(WM_OBR_SCANNING, OnScan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoSpkSampleVCDlg bZ[W nh

BOOL CMoSpkSampleVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);					// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);				// ACRݒ
	
	ShowWindow( SW_SHOWMAXIMIZED );			// ʂő剻܂

	// OBRI[v܂B
	int iRet = OBROpen( m_hWnd, 0 );
	if( iRet != OBR_OK )
	{
		// G[bZ[W\܂B
		::AfxMessageBox( _T("OBRI[vG[") );

		// _CAOI܂B
		EndDialog( IDCANCEL );
	}
	m_bOBROpen = TRUE;

	// 䃉CuI[v܂B
	m_hDevice = MoSpk_Open();
	if( m_hDevice == NULL )
	{
		// G[bZ[W\܂B
		::AfxMessageBox( _T("䃉CuI[vG[") );
	
		// _CAOI܂B
		EndDialog( IDCANCEL );
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵Ȃꍇ TRUE Ԃ܂
}

// mF{^Cxgnh
void CMoSpkSampleVCDlg::OnSpeak() 
{
	TCHAR tSpeak[SPEAK_MAX_LEN] = {0};
	GetDlgItemText( IDC_EDIT_QTY, tSpeak, SPEAK_MAX_LEN + 1 );

	// ǂݏグ܂B
	MoSpk_Speak( m_hDevice, tSpeak, MOSPK_MODE_ORDINAL | MOSPK_MODE_ASYNC | MOSPK_MODE_STOP | MOSPK_MODE_QUANTITY );
}

// o[R[hXLCxgnh
LRESULT CMoSpkSampleVCDlg::OnScan( UINT wParam, LONG lParam )
{
	// o[R[hXL
	BYTE bDecodeData[SCANCODE_MAX_LEN];
	BYTE bLen;
	TCHAR tDecodeData[SCANCODE_MAX_LEN];
	DWORD dwCode;

	// o͌
	TCHAR tSpeak[SPEAK_MAX_LEN] = {0};

	// o[R[hXLʂ܂B
	memset( bDecodeData, 0x00, sizeof(bDecodeData) );
	memset( tDecodeData, 0x00, sizeof(tDecodeData) );
	dwCode = OBR_NONDT;
	bLen = 0;

	// o[R[hXLʂ擾܂B
	OBRGets( bDecodeData, &dwCode, &bLen );
	if(dwCode == OBR_NONDT){
		return 0;
	}

	// \f[^NA܂B
	CWnd *pCodeWnd = GetDlgItem( IDC_EDIT_SCANCODE );
	pCodeWnd->SetWindowText( _T("") );
	CWnd *pQtyWnd = GetDlgItem( IDC_EDIT_QTY );
	pQtyWnd->SetWindowText( _T("") );

	// o[R[hXLʂ\܂B
	MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, (LPCSTR)bDecodeData, SCANCODE_MAX_LEN, tDecodeData, SCANCODE_MAX_LEN );
	pCodeWnd->SetWindowText( tDecodeData );

	// \̎擾܂B
	int iSpeak = SetQuantity();

	// \܂B
	_stprintf( tSpeak, _T("%d"), iSpeak );
	pQtyWnd->SetWindowText( tSpeak );

	// mF{^Cxg𔭐܂B
	PostMessage( WM_COMMAND, IDC_SPEAK );

	return 0;
}

// ftHgOK{^/^[L[Cxgnh
void CMoSpkSampleVCDlg::OnOK() 
{
	// ftHgOK{^/^[L[ŉo͂܂B
	OnSpeak();
}

// \̎擾
int CMoSpkSampleVCDlg::SetQuantity()
{
	// ̃TvvOł́A𗐐狁߂Ă܂B
	// {֐邱ƂŁACӂ̌\邱Ƃł܂B

	int iQty = 0;

	// 0`999̗𔭐܂
	srand( GetTickCount() );
	iQty = rand() % 1000;

	return iQty;
}

