/***************************************************************************
 * <Description>
 * MoSpkMain.cpp (Casio Computer Co., Ltd.)
 * -------------------------------------------------------------------------
 * <Function outline>
 * Voice output Library Demo program
 * -------------------------------------------------------------------------
 * <Language>
 * Visual C++
 * -------------------------------------------------------------------------
 * <Develop Environment>
 * VS 2005
 * -------------------------------------------------------------------------
 * <Target>
 * DT-5300 WM / IT-300 (Japanese Voice only supported)
 * -------------------------------------------------------------------------
 * Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
 * -------------------------------------------------------------------------
 * <History>
 * Version  Date            Company     Keyword     Comment
 * 1.0.0    2010.05.29      CASIO       000000      Original      
 * 
 ***************************************************************************/
//	000000__	Original
//	__000000	Original

#include <windows.h>
#include "resource.h"
#include <aygshell.h>

//	000000__	Original
//  CASIO Libaray
#include "MoSpk.h"
//	__000000	Original

BOOL DlgMOSPK(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL VOICE_Output(HWND hDlg);


int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPWSTR lpCmdLine, int nShowCmd)
{
	DialogBoxW(hInstance, MAKEINTRESOURCE( IDD_MOSPK ), NULL, DlgMOSPK);
	return 0;
}

BOOL DlgMOSPK(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			RECT rc;
			#define MENU_HEIGHT 26

            // Create a Done button and size it.  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_SIPDOWN | SHIDIF_FULLSCREENNOMENUBAR ;
            shidi.hDlg = hDlg;
            SHInitDialog(&shidi);
				
			GetWindowRect(hDlg, &rc);
			MoveWindow(hDlg, rc.left, rc.top, rc.right, rc.bottom+MENU_HEIGHT, TRUE);

			SetForegroundWindow(hDlg);
			SHFullScreen(hDlg, SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);	
		}

		SetDlgItemText(hDlg, IDC_NO1, _T("1"));
		SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_ADDSTRING, 0, (LPARAM)_T("MOSPK_MODE_CARDINAL"));
		SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_ADDSTRING, 0, (LPARAM)_T("MOSPK_MODE_ORDINAL"));
		SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_ADDSTRING, 0, (LPARAM)_T("MOSPK_MODE_QUANTITY"));
		SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_ADDSTRING, 0, (LPARAM)_T("MOSPK_MODE_YEN"));
		SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_ADDSTRING, 0, (LPARAM)_T("MOSPK_MODE_NONE"));
		SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_SETCURSEL, 0, 0);


        return (INT_PTR)TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_EXIT:
			EndDialog(hDlg, LOWORD(wParam));
			break;

		case IDC_VOICE:
			VOICE_Output(hDlg);
			break;
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hDlg);
		break;
	}
	return FALSE;
}

BOOL VOICE_Output(HWND hDlg)
{

	TCHAR	szNumber[12];
	int		iNumberSize;

	ZeroMemory( szNumber, sizeof(szNumber) );
	iNumberSize = sizeof( szNumber );

	GetDlgItemText( hDlg, IDC_NO1, szNumber, iNumberSize );


	HANDLE hRet;
	DWORD dwMode;

	hRet = MoSpk_Open();

	if (SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_GETCURSEL,0 ,0 ) == 0)
	{
		dwMode = MOSPK_MODE_CARDINAL;
	}
	else if (SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_GETCURSEL,0 ,0 ) == 1)
	{
		dwMode = MOSPK_MODE_ORDINAL;
	}
	else if (SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_GETCURSEL,0 ,0 ) == 2)
	{
		dwMode = MOSPK_MODE_QUANTITY | MOSPK_MODE_ORDINAL;
	}
	else if (SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_GETCURSEL,0 ,0 ) == 3)
	{
		dwMode = MOSPK_MODE_YEN | MOSPK_MODE_ORDINAL;
	}
	else if (SendMessage(GetDlgItem(hDlg,IDC_PARA), CB_GETCURSEL,0 ,0 ) == 4)
	{
		dwMode = MOSPK_MODE_NONE | MOSPK_MODE_ORDINAL;
	}


	MoSpk_Speak(hRet, szNumber, dwMode);

	MoSpk_Close(hRet);


	return TRUE;
}