'***************************************************************************
'* <Description>
'* NFCHFTagMain.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* NFC HFTag IC Card reading Demo program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target>
'* IT-9000 CE model
'* -------------------------------------------------------------------------
'* Copyright(C)2012 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2012.05.24      CASIO       000000      Original      
'* 
'***************************************************************************/

Imports Calib.NFCHFTagLibNet.Api
Imports Calib.NFCHFTagLibNet.Def
Imports Calib.SystemLibNet.Api
Imports Calib.SystemLibNet.Def

Public Class MFCHFTagMain
    Dim iRet As Integer
    Dim strCommand As String
    Dim byDSFID(1) As Byte
    Dim pUID(8) As Byte
    Dim pData(16) As Byte
    Dim dwActualSize As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim i As Integer

        Button1.Enabled = False

        Label6.Text = ""
        Label7.Text = ""
        TextBox2.Text = ""
        TextBox3.Text = ""
        Application.DoEvents()

        'NFCHFTag POLLING
        TextBox3.Text = "NFCHFTagPolling...start." + ControlChars.NewLine + TextBox3.Text
        iRet = NFCHFTagPolling(10000, IntPtr.Zero, 0, 0, 0)
        If iRet <> NFC_OK Then
            strCommand = "NFCHFTagPolling"
            DispErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        TextBox3.Text = "NFCHFTagPolling...OK." + ControlChars.NewLine + TextBox3.Text


        'NFCHFTag GET CARD RESPONSE
        TextBox3.Text = "NFCHFTagGetCardResponse...start." + ControlChars.NewLine + TextBox3.Text
        iRet = NFCHFTagGetCardResponse(byDSFID, pUID, 0)
        TextBox3.Text = "NFCHFTagGetCardResponse...OK." + ControlChars.NewLine + TextBox3.Text
        For i = 0 To 0
            Label6.Text = Label6.Text + byDSFID(i).ToString("X2") + " "
        Next
        For i = 0 To 7
            Label7.Text = Label7.Text + pUID(i).ToString("X2") + " "
        Next

        If ComboBox1.SelectedIndex = 1 Then '1 = READ
            TextBox3.Text = "NFCHFTagRead...start." + ControlChars.NewLine + TextBox3.Text
            iRet = NFCHFTagRead(CInt(TextBox1.Text.ToString), pData, dwActualSize, 0, 0)
            If iRet <> NFC_OK Then
                strCommand = "NFCHFTagRead"
                DispErrorMessage(iRet, strCommand)
                Exit Sub
            End If
            TextBox3.Text = "NFCHFTagRead...OK." + ControlChars.NewLine + TextBox3.Text
            For i = 0 To dwActualSize
                TextBox2.Text = TextBox2.Text + pData(i).ToString("X2")
            Next

        ElseIf ComboBox1.SelectedIndex = 2 Then '2 = WRITE
            TextBox3.Text = "NFCHFTagWrite...start." + ControlChars.NewLine + TextBox3.Text
            'Append your NFCHFTagWrite code.
            TextBox3.Text = "NFCHFTagWrite...OK." + ControlChars.NewLine + TextBox3.Text
        End If

        ' NFCMifare RADIO OFF
        TextBox3.Text = "NFCHFTagRadioOff...start." + ControlChars.NewLine + TextBox3.Text
        iRet = NFCHFTagRadioOff()
        If iRet <> NFC_OK Then
            strCommand = "NFCHFTagRadioOff"
            DispErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        TextBox3.Text = "NFCHFTagRadioOff...OK." + ControlChars.NewLine + TextBox3.Text

        Button1.Enabled = True
        TextBox3.Text = "NFCHFTag scanning" + ControlChars.NewLine + TextBox3.Text
        SysSetBuzzerVolume(B_SCANEND, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_SCANEND, B_USERDEF, B_USERDEF)

    End Sub

    Function DispErrorMessage(ByVal iRet As Integer, ByVal strCommand As String) As Boolean
        Select Case iRet
            Case NFC_PON
                TextBox3.Text = strCommand + " : NFC already opend." + ControlChars.NewLine + TextBox3.Text
            Case NFC_NOT_DEVICE
                TextBox3.Text = strCommand + " : NFC driver error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_INVALID_ACCESS
                TextBox3.Text = strCommand + " : Device exclusive error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_MODULE
                TextBox3.Text = strCommand + " : NFC module not responce error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_POF
                TextBox3.Text = strCommand + " : NFC not open error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_PRM
                TextBox3.Text = strCommand + " : NFC parameter error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_TIMEOUT
                TextBox3.Text = strCommand + " : Timeout error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_CALLBACK
                TextBox3.Text = strCommand + " : Call back function error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_STOP
                TextBox3.Text = strCommand + " : Stop error by stop function." + ControlChars.NewLine + TextBox3.Text
            Case NFC_NOT_ACTIVATION
                TextBox3.Text = strCommand + " : Card don't start error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_SUSPEND
                TextBox3.Text = strCommand + " : Terminal OFF occurred error." + ControlChars.NewLine + TextBox3.Text
            Case NFC_ERROR_AUTOOFF
                TextBox3.Text = strCommand + " : Radio Auto Stop error." + ControlChars.NewLine + TextBox3.Text
            Case Else
                TextBox3.Text = strCommand + " : Other error." + ControlChars.NewLine + TextBox3.Text
        End Select

        SysSetBuzzerVolume(B_WARNING, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_WARNING, B_USERDEF, B_USERDEF)

        ' NFCHFTagClose()
        Button1.Enabled = True
    End Function
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ShowTaskbar()
        Me.Close()
    End Sub

    Private Sub NFCHFTagMain_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        ' NFC CLOSE
        NFCHFTagClose()
    End Sub

    Private Sub NFCHFTagMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        HideTaskbar()
        ComboBox1.SelectedIndex = 0

        ' NFC OPEN
        iRet = NFCHFTagOpen(IntPtr.Zero)

        TextBox3.Text = "NFCHFTagOpen...start." + ControlChars.NewLine + TextBox3.Text

        If iRet <> NFC_OK Then
            strCommand = "NFCHFTagOpen"
            DispErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        TextBox3.Text = "NFCHFTagOpen...OK." + ControlChars.NewLine + TextBox3.Text
    End Sub

End Class
