/***************************************************************************
 * <Description>
 * Common.cs (Casio Computer Co., Ltd.)
 * -------------------------------------------------------------------------
 * <Function outline>
 * Common Sub-routine
 *  1 : Hide Taskbar    HideTaskbar()
 *  2 : Show Taskbar    ShowTaskbar()
 *
 * Using Win32 API
 *  1 : FindWindow
 *  2 : ShowWindow
 * -------------------------------------------------------------------------
 * <Language>
 * C#.NET
 * -------------------------------------------------------------------------
 * <Develop Environment>
 * VS 2005
 * -------------------------------------------------------------------------
 * Copyright(C)2009 CASIO COMPUTER CO.,LTD. All rights reserved.
 * -------------------------------------------------------------------------
 * <History>
 * Version  Date            Company     Keyword     Comment
 * 1.0.0    2009.09.24      CASIO       000000      Original      
 * 
 ***************************************************************************/
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace NFCLibSampleCECS
{
    public class Common
    {
        //        '*** WIN32API constants ***
        //'ShowWindow() function
        public const int SW_HIDE = 0;
        public const int SW_SHOWNORMAL = 1;
        public const int SW_NORMAL = 1;
        public const int SW_SHOWMINIMIZED = 2;
        public const int SW_SHOWMAXIMIZED = 3;
        public const int SW_MAXIMIZE = 3;
        public const int SW_SHOWNOACTIVATE = 4;
        public const int SW_SHOW = 5;
        public const int SW_MINIMIZE = 6;
        public const int SW_SHOWMINNOACTIVE = 7;
        public const int SW_SHOWNA = 8;
        public const int SW_RESTORE = 9;
        public const int SW_SHOWDEFAULT = 10;
        public const int SW_FORCEMINIMIZE = 11;
        public const int SW_MAX = 11;

        //'************************************************************
        //'   Structure definition
        //'************************************************************


        //'************************************************************
        //'   WIN32API inport
        //'************************************************************

        [DllImport("CoreDll.dll")]
        public static extern int FindWindow(string lpClassName,
            string lpWindowName);

        [DllImport("CoreDll.dll")]
        public static extern int ShowWindow(int hwnd,
            int nCmdShow);

        [DllImport("CoreDll.dll")]
        public static extern IntPtr GetForegroundWindow();

        //'************************************************************
        //'   Hide Taskbar
        //'************************************************************
        public static void HideTaskbar()
        {
            int lpTaskBarHwnd;

            lpTaskBarHwnd = FindWindow("HHTaskBar", "");
            ShowWindow(lpTaskBarHwnd, SW_HIDE);
        }

        //'************************************************************
        //'   Show Taskbar
        //'************************************************************
        public static void ShowTaskbar()
        {
            int lpTaskBarHwnd;

            lpTaskBarHwnd = FindWindow("HHTaskBar", "");
            ShowWindow(lpTaskBarHwnd, SW_SHOW);
        }
    }
}