/***************************************************************************
 * <Description>
 * NFCMain.cs (Casio Computer Co., Ltd.)
 * -------------------------------------------------------------------------
 * <Function outline>
 * NFC IC Card reading Demo program
 * -------------------------------------------------------------------------
 * <Language>
 * C#.NET
 * -------------------------------------------------------------------------
 * <Develop Environment>
 * VS 2005
 * -------------------------------------------------------------------------
 * <Target>
 * DT-5300 CE model
 * -------------------------------------------------------------------------
 * Copyright(C)2009 CASIO COMPUTER CO.,LTD. All rights reserved.
 * -------------------------------------------------------------------------
 * <History>
 * Version  Date            Company     Keyword     Comment
 * 1.0.0    2009.10.14      CASIO       000000      Original      
 * 1.0.1    2012.05.24      CASIO       000001      Modify        
 * 
 ***************************************************************************/
//	000001__	Modify
// In case of DT-5300 CE, append following definitions.
//#define DRAW_IC_CARD_IMAGE
//#define HFTAG_UNSUPPORTED
#undef DRAW_IC_CARD_IMAGE
#undef HFTAG_UNSUPPORTED
//	__000001	Modify

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Calib;

namespace NFCLibSampleCECS
{
    public partial class NFCMain : Form
    {
        public NFCMain()
        {
            InitializeComponent();
        }
        int iActBaudRate;
        int iRet;
        byte[] cTargetData = new byte[261];
        int iLen;
        int iCardType;

        private void Button1_Click(object sender, EventArgs e)
        {
            Button1.Enabled = false;
            //	000001__	Modify
#if DRAW_IC_CARD_IMAGE
            PictureBox1.Visible = true;
#else
            PictureBox1.Visible = false;
#endif
            //	__000001	Modify

            TextBox1.Text = "";
            Label2.Text = "";
            Label3.Text = "";
            Label7.Text = "";
            Application.DoEvents();

            // NFC OPEN
            //iRet = NFCLibNet.Api.NFCOpen(IntPtr.Zero);

            //TextBox2.Text = "NFCOpen...start.";

            //if (iRet != NFCLibNet.Def.NFC_OK)
            //{
            //    DispErrorMessage(iRet);
            //    return;
            //}

            TextBox2.Text = "NFCPollingCard...start.";

            // NFC POLLING 
            iRet = NFCLibNet.Api.NFCPollingCard(NFCLibNet.Def.NFC_BAUD_TYPEA |
                                                NFCLibNet.Def.NFC_BAUD_TYPEB |
                                                NFCLibNet.Def.NFC_BAUD_FELICA1 |
                                                NFCLibNet.Def.NFC_BAUD_FELICA2
            //	000001__	Modify
#if HFTAG_UNSUPPORTED
#else
                                                | NFCLibNet.Def.NFC_BAUD_HFTAGE
#endif
            //	__000001	Modify
                                                , 10000, IntPtr.Zero, ref iActBaudRate, 0);
            if (iRet != NFCLibNet.Def.NFC_OK)
            {
                DispErrorMessage(iRet);
                return;
            }

            TextBox2.Text = "NFCPollingCard...OK.";

            if (iActBaudRate == NFCLibNet.Def.NFC_BAUD_TYPEA)
                Label2.Text = "Type A";
            else if (iActBaudRate == NFCLibNet.Def.NFC_BAUD_TYPEB)
                Label2.Text = "Type B";
            else if (iActBaudRate == NFCLibNet.Def.NFC_BAUD_FELICA1)
                Label2.Text = "Felica";
            else if (iActBaudRate == NFCLibNet.Def.NFC_BAUD_FELICA2)
                Label2.Text = "Felica";
            //	000001__	Modify
#if HFTAG_UNSUPPORTED
#else
            else if (iActBaudRate == NFCLibNet.Def.NFC_BAUD_HFTAGE)
                Label2.Text = "ISO15693";
#endif
            //	__000001	Modify

            iCardType = iActBaudRate;

            TextBox2.Text = "NFCGetCardResponse...start.";

            // NFC GET CARD RESPONSE
            iRet = NFCLibNet.Api.NFCGetCardResponse(cTargetData, ref iLen, 0);

            if (iRet != NFCLibNet.Def.NFC_OK)
            {
                DispErrorMessage(iRet);
                return;
            }

            TextBox2.Text = "NFCGetCardResponse...OK.";
            Label3.Text = iLen.ToString();

            int i;

            for (i = 0; i < iLen; i++)
            {
                TextBox1.Text = TextBox1.Text + cTargetData[i].ToString("X2") + " ";
            }

            switch (Label2.Text)
            {
                case "Type A":
                    int UidLen;
                    UidLen = (int)cTargetData[3];

                    for (i = 0; i < UidLen; i++)
                    {
                        Label7.Text = Label7.Text + cTargetData[4 + i].ToString("X2") + " ";
                    }
                    break;
                case "Type B":
                    for (i = 1; i < 5; i++)
                    {
                        Label7.Text = Label7.Text + cTargetData[i].ToString("X2") + " ";
                    }
                    break;
                case "Felica":
                    for (i = 0; i < 8; i++)     // 1to7 -> 0to7
                    {
                        Label7.Text = Label7.Text + cTargetData[i].ToString("X2") + " ";
                    }
                    break;
                //	000001__	Modify
#if HFTAG_UNSUPPORTED
#else
                case "ISO15693":
                    for (i = 0; i < 8; i++)
                    {
                        Label7.Text = Label7.Text + cTargetData[1 + i].ToString("X2") + " ";
                    }
                    break;
#endif
                //	__000001	Modify
            }

            TextBox2.Text = "NFCRadioOff...start.";

            //NFC RADIO OFF
            iRet = NFCLibNet.Api.NFCRadioOff();

            if (iRet != NFCLibNet.Def.NFC_OK)
            {
                DispErrorMessage(iRet);
                return;
            }

            TextBox2.Text = "NFCRadioOff...OK.";

            // NFC CLOSE
            //NFCLibNet.Api.NFCClose();

            Button1.Enabled = true;
            TextBox2.Text = "NFC scanning...OK.";
            SystemLibNet.Api.SysSetBuzzerVolume(SystemLibNet.Def.B_SCANEND, SystemLibNet.Def.BUZZERVOLUME_MAX);
            SystemLibNet.Api.SysPlayBuzzer(SystemLibNet.Def.B_SCANEND, SystemLibNet.Def.B_USERDEF, SystemLibNet.Def.B_USERDEF);
            //	000001__	Modify
#if DRAW_IC_CARD_IMAGE
            PictureBox1.Visible = false;
#endif
            //	__000001	Modify
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Button3_Click(object sender, EventArgs e)
        {
            NFCHelp frmNFCHelp;
            frmNFCHelp = new NFCHelp();
            frmNFCHelp.Show();
        }

        private void DispErrorMessage(int iRet)
        {
            switch (iRet)
            {
                case NFCLibNet.Def.NFC_PON:
                    TextBox2.Text = "Error : NFC already opend.";
                    break;
                case NFCLibNet.Def.NFC_NOT_DEVICE:
                    TextBox2.Text = "Error : NFC driver error.";
                    break;
                case NFCLibNet.Def.NFC_ERROR_INVALID_ACCESS:
                    TextBox2.Text = "Error : Device exclusive error.";
                    break;
                case NFCLibNet.Def.NFC_ERROR_MODULE:
                    TextBox2.Text = "Error : NFC module not responce error.";
                    break;
                case NFCLibNet.Def.NFC_POF:
                    TextBox2.Text = "Error : NFC not open error.";
                    break;
                case NFCLibNet.Def.NFC_PRM:
                    TextBox2.Text = "Error : NFC parameter error.";
                    break;
                case NFCLibNet.Def.NFC_ERROR_TIMEOUT:
                    TextBox2.Text = "Error : Timeout error.";
                    break;
                case NFCLibNet.Def.NFC_ERROR_CALLBACK:
                    TextBox2.Text = "Error : Call back function error.";
                    break;
                case NFCLibNet.Def.NFC_ERROR_STOP:
                    TextBox2.Text = "Error : Stop error by stop function.";
                    break;
                case NFCLibNet.Def.NFC_NOT_ACTIVATION:
                    TextBox2.Text = "Error : Card don't start error.";
                    break;
                default:
                    TextBox2.Text = "Error : Other error.";
                    break;
            }
            SystemLibNet.Api.SysSetBuzzerVolume(SystemLibNet.Def.B_WARNING, SystemLibNet.Def.BUZZERVOLUME_MAX);
            SystemLibNet.Api.SysPlayBuzzer(SystemLibNet.Def.B_WARNING, SystemLibNet.Def.B_USERDEF, SystemLibNet.Def.B_USERDEF);

            //NFCLibNet.Api.NFCClose();
            Button1.Enabled = true;
            //	000001__	Modify
#if DRAW_IC_CARD_IMAGE
            PictureBox1.Visible = false;
#endif
            //	__000001	Modify
        }

        private void NFCMain_Load(object sender, EventArgs e)
        {
            //	000001__	Modify
#if DRAW_IC_CARD_IMAGE
            Button3.Visible = true;
#else
            Button3.Visible = false;
#endif
            // NFC OPEN
            iRet = NFCLibNet.Api.NFCOpen(IntPtr.Zero);

            TextBox2.Text = "NFCOpen...start.";

            if (iRet != NFCLibNet.Def.NFC_OK)
            {
                DispErrorMessage(iRet);
                return;
            }
            //	__000001	Modify
        }

        private void NFCMain_Closed(object sender, EventArgs e)
        {
            //	000001__	Modify
            // NFC CLOSE
            NFCLibNet.Api.NFCClose();
            //	__000001	Modify
        }

    }
}