'***************************************************************************
'* <Description>
'* NFCMain.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* NFC IC Card reading Demo program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target>
'* DT-5300 CE model
'* -------------------------------------------------------------------------
'* Copyright(C)2009 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2009.10.14      CASIO       000000      Original      
'* 1.0.1    2012.05.24      CASIO       000001      Modify      
'* 
'***************************************************************************/
'	000001__	Modify
' In case of DT-5300 CE, append following definitions.
#Const DRAW_IC_CARD_IMAGE = False
#Const HFTAG_UNSUPPORTED = False
'	__000001	Modify

Imports Calib.NFCLibNet.Api
Imports Calib.NFCLibNet.Def
Imports Calib.SystemLibNet.Api
Imports Calib.SystemLibNet.Def

Public Class NFCMain
    Dim iActBaudRate As Integer
    Dim iRet As Integer

    Dim cTargetData(261) As Byte
    Dim iLen As Integer
    Dim iCardType As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button1.Enabled = False
        '	000001__	Modify
#If DRAW_IC_CARD_IMAGE Then
        PictureBox1.Visible = true
#Else
        PictureBox1.Visible = False
#End If
        '	__000001	Modify

        TextBox1.Text = ""
        Label2.Text = ""
        Label3.Text = ""
        Label7.Text = ""
        Application.DoEvents()

        ' NFC OPEN
        'iRet = NFCOpen(IntPtr.Zero)

        'TextBox2.Text = "NFCOpen...start."

        'If iRet <> NFC_OK Then
        '    DispErrorMessage(iRet)
        '    Exit Sub
        'End If

        TextBox2.Text = "NFCPollingCard...start."

        ' NFC POLLING
        '	000001__	Modify
#If HFTAG_UNSUPPORTED Then
        iRet = NFCPollingCard(NFC_BAUD_TYPEA Or NFC_BAUD_TYPEB Or NFC_BAUD_FELICA1 Or NFC_BAUD_FELICA2, 10000, IntPtr.Zero, iActBaudRate, 0)
#Else
        iRet = NFCPollingCard(NFC_BAUD_TYPEA Or NFC_BAUD_TYPEB Or NFC_BAUD_FELICA1 Or NFC_BAUD_FELICA2 Or NFC_BAUD_HFTAGE, 10000, IntPtr.Zero, iActBaudRate, 0)
#End If
        '	__000001	Modify

        If iRet <> NFC_OK Then
            DispErrorMessage(iRet)
            Exit Sub
        End If

        TextBox2.Text = "NFCPollingCard...OK."

        If iActBaudRate = NFC_BAUD_TYPEA Then
            Label2.Text = "Type A"
        ElseIf iActBaudRate = NFC_BAUD_TYPEB Then
            Label2.Text = "Type B"
        ElseIf iActBaudRate = NFC_BAUD_FELICA1 Then
            Label2.Text = "Felica"
        ElseIf iActBaudRate = NFC_BAUD_FELICA2 Then
            Label2.Text = "Felica"
            '	000001__	Modify
#If HFTAG_UNSUPPORTED Then
#Else
        ElseIf iActBaudRate = NFC_BAUD_HFTAGE Then
            Label2.Text = "ISO15693"
#End If
            '	__000001	Modify
        End If

        iCardType = iActBaudRate

        TextBox2.Text = "NFCGetCardResponse...start."

        ' NFC GET CARD RESPONSE
        iRet = NFCGetCardResponse(cTargetData, iLen, 0)

        If iRet <> NFC_OK Then
            DispErrorMessage(iRet)
            Exit Sub
        End If

        TextBox2.Text = "NFCGetCardResponse...OK."

        Label3.Text = iLen.ToString

        Dim i As Integer

        For i = 0 To iLen - 1
            TextBox1.Text = TextBox1.Text + cTargetData(i).ToString("X2") + " "
        Next

        Select Case Label2.Text
            Case "Type A"
                Dim UidLen As Integer
                UidLen = Val(cTargetData(3))
                For i = 0 To UidLen - 1
                    Label7.Text = Label7.Text + cTargetData(4 + i).ToString("X2") + " "
                Next

            Case "Type B"
                For i = 1 To 4
                    Label7.Text = Label7.Text + cTargetData(i).ToString("X2") + " "
                Next
            Case "Felica"
                For i = 0 To 7
                    Label7.Text = Label7.Text + cTargetData(i).ToString("X2") + " "
                Next
                '	000001__	Modify
#If HFTAG_UNSUPPORTED Then
#Else
            Case "ISO15693"
                For i = 0 To 7
                    Label7.Text = Label7.Text + cTargetData(1 + i).ToString("X2") + " "
                Next
#End If
                '	__000001	Modify
        End Select

        TextBox2.Text = "NFCRadioOff...start."

        ' NFC RADIO OFF
        iRet = NFCRadioOff()

        If iRet <> NFC_OK Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        TextBox2.Text = "NFCRadioOff...OK."

        ' NFC CLOSE
        'NFCClose()

        Button1.Enabled = True
        TextBox2.Text = "NFC scanning...OK."
        SysSetBuzzerVolume(B_SCANEND, BUZZERVOLUME_MAX)

        SysPlayBuzzer(B_SCANEND, B_USERDEF, B_USERDEF)
        '	000001__	Modify
#If DRAW_IC_CARD_IMAGE Then
        PictureBox1.Visible = False
#End If
        '	__000001	Modify
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim frmNFCHelp As New NFCHelp
        frmNFCHelp.Show()
    End Sub

    Function DispErrorMessage(ByVal iRet As Integer) As Boolean
        Select Case iRet
            Case NFC_PON
                TextBox2.Text = "Error : NFC already opend."
            Case NFC_NOT_DEVICE
                TextBox2.Text = "Error : NFC driver error."
            Case NFC_ERROR_INVALID_ACCESS
                TextBox2.Text = "Error : Device exclusive error."
            Case NFC_ERROR_MODULE
                TextBox2.Text = "Error : NFC module not responce error."
            Case NFC_POF
                TextBox2.Text = "Error : NFC not open error."
            Case NFC_PRM
                TextBox2.Text = "Error : NFC parameter error."
            Case NFC_ERROR_TIMEOUT
                TextBox2.Text = "Error : Timeout error."
            Case NFC_ERROR_CALLBACK
                TextBox2.Text = "Error : Call back function error."
            Case NFC_ERROR_STOP
                TextBox2.Text = "Error : Stop error by stop function."
            Case NFC_NOT_ACTIVATION
                TextBox2.Text = "Error : Card don't start error."
            Case Else
                TextBox2.Text = "Error : Other error."
        End Select

        SysSetBuzzerVolume(B_WARNING, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_WARNING, B_USERDEF, B_USERDEF)

        'NFCClose()
        Button1.Enabled = True
        '	000001__	Modify
#If DRAW_IC_CARD_IMAGE Then
        PictureBox1.Visible = False
#End If
        '	__000001	Modify
    End Function

    Private Sub NFCMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '	000001__	Modify
#If DRAW_IC_CARD_IMAGE Then
        Button3.Visible = true
#Else
        Button3.Visible = False
#End If

        ' NFC OPEN
        iRet = NFCOpen(IntPtr.Zero)

        TextBox2.Text = "NFCOpen...start."

        If iRet <> NFC_OK Then
            DispErrorMessage(iRet)
            Exit Sub
        End If
        '	__000001	Modify

    End Sub

    Private Sub NFCMain_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        '	000001__	Modify
        ' NFC CLOSE
        NFCClose()
        '	__000001	Modify

    End Sub
End Class