/***************************************************************************
'* <Description>
'* Form1.cs (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* OBR Library Sample program
'* -------------------------------------------------------------------------
'* <Language>
'* C#.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target> : Windows Mobile Model
'* JPN : DT-5300WM / IT-300
'* ENG : DT-X30WM / IT-800 / IT-300
'* -------------------------------------------------------------------------
'* Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2010.02.17      CASIO       000000      Original      
'* 
'***************************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;
using Calib;

namespace OBReadLibSampleWMCS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("coredll.dll")]
        public static extern IntPtr GetForegroundWindow();

        public static IntPtr HWND;
        private System.Threading.Thread thread;
        //Barcode type
        static int[] DecodeNum = {
									  OBReadLibNet.Def.OBR_NONDT,
									  OBReadLibNet.Def.OBR_CD39,
									  OBReadLibNet.Def.OBR_NW_7,
									  OBReadLibNet.Def.OBR_WPCA,
									  OBReadLibNet.Def.OBR_WPC,
									  OBReadLibNet.Def.OBR_UPEA,
									  OBReadLibNet.Def.OBR_UPE,
									  OBReadLibNet.Def.OBR_IDF,
									  OBReadLibNet.Def.OBR_ITF,
									  OBReadLibNet.Def.OBR_CD93,
									  OBReadLibNet.Def.OBR_CD128,
									  OBReadLibNet.Def.OBR_MSI,
									  OBReadLibNet.Def.OBR_IATA
								  };

        static string[] DecodeName = {
										 "          ",
										 "OBR_CD39  ",
										 "OBR_NW_7  ",
										 "OBR_WPCA  ",
										 "OBR_WPC   ",
										 "OBR_UPEA  ",
										 "OBR_UPE   ",
										 "OBR_IDF   ",
										 "OBR_ITF   ",
										 "OBR_CD93  ",
										 "OBR_CD128 ",
										 "OBR_MSI   ",
										 "OBR_IATA  "
									 };

        private void Form1_Load(object sender, EventArgs e)
        {
            int iRet;

            HWND = GetForegroundWindow();
            iRet = OBReadLibNet.Api.OBRLoadConfigFile();		//ini File read default value set
            iRet = OBReadLibNet.Api.OBRSetDefaultSymbology();	//1D(OBR) driver mode will be ini File vallue
            iRet = OBReadLibNet.Api.OBRSetScanningKey(OBReadLibNet.Def.OBR_TRIGGERKEY_L | OBReadLibNet.Def.OBR_TRIGGERKEY_R | OBReadLibNet.Def.OBR_CENTERTRIGGER);
            iRet = OBReadLibNet.Api.OBRSetScanningCode(OBReadLibNet.Def.OBR_ALL);
            iRet = OBReadLibNet.Api.OBRSetBuffType(OBReadLibNet.Def.OBR_BUFOBR);	//1D(OBR) driver mode will be OBR_BUFOBR
            iRet = OBReadLibNet.Api.OBRSetScanningNotification(OBReadLibNet.Def.OBR_EVENT, IntPtr.Zero);	//1D(OBR) driver mode will be OBR_EVENT
            iRet = OBReadLibNet.Api.OBROpen(HWND, 0);			//OBRDRV open

            if (iRet == OBReadLibNet.Def.OBR_ERROR_INVALID_ACCESS)
            {
                MessageBox.Show("Failed to connect to the scanner. Please exit a scanner application.", "OBRLibSampleCS");
                return;
            }
            else if (iRet == OBReadLibNet.Def.OBR_ERROR_HOTKEY)
            {
                MessageBox.Show("Trigger keys are being used. Please quit the program which is using the trigger keys.", "OBRLibSampleCS");
                return;
            }
            else if (iRet != OBReadLibNet.Def.OBR_OK)
            {
                MessageBox.Show("Failed to connect to the scanner.", "OBRLibSampleCS");
                return;
            }

            iRet = OBReadLibNet.Api.OBRClearBuff();
            thread = new Thread(new ThreadStart(start));
            thread.Start();     //Start start thread
        }

        delegate void SetLabelText();

        private void SetText()
        {
            int leng = new int();	//digit number
            byte leng2 = new byte();//digit number
            int dwrcd = new int();	//barcode type
            int ret;
            byte lcnt = new byte();
            byte[] buff = new byte[1024];
            string str;
            int i;

            if (HWND != IntPtr.Zero)
            {	// check OBRBuffer state
                ret = OBReadLibNet.Api.OBRGetStatus(ref leng, ref lcnt);
                if (leng != 0)
                {
                    // get OBRBuffer data
                    ret = OBReadLibNet.Api.OBRGets(buff, ref dwrcd, ref leng2);
                    Encoding ASCII = Encoding.GetEncoding("ascii");
                    textBox1.Text = ASCII.GetString(buff, 0, leng2);	//scan barcode type display

                    str = "----------";
                    for (i = 0; i < 13; i++)
                    {
                        if (DecodeNum[i] == dwrcd)
                        {
                            str = DecodeName[i];
                            break;
                        }
                    }
                    textBox2.Text = str;				//scan barcode type display
                    textBox3.Text = leng2.ToString();	//digit number display
                    textBox4.Text = ret.ToString();		//end information display
                }
                OBReadLibNet.Api.OBRClearBuff();
            }
        }

        private void start()
        {
            while (true)
            {
                SystemLibNet.Api.SysWaitForEvent(IntPtr.Zero, OBReadLibNet.Def.OBR_NAME_EVENT, SystemLibNet.Def.INFINITE);  //Wait event
                Invoke(new SetLabelText(SetText));      //Display OBRBuffer data
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OBReadLibNet.Api.OBRClose();				//OBRDRV Close
            SystemLibNet.Api.SysTerminateWaitEvent();	//End SysWaitForEvent function
            HWND = IntPtr.Zero;
            textBox1.Text = "";
            textBox2.Text = "";
            textBox3.Text = "";
            textBox4.Text = "";
            thread.Abort();
            this.Close();
        }


    }
}