'***************************************************************************
'* <Description>
'* Form1.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* OBR Library Sample program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target> : Windows Mobile Model
'* JPN : DT-5300WM / IT-300
'* ENG : DT-X30WM / IT-800 / IT-300
'* -------------------------------------------------------------------------
'* Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2010.02.17      CASIO       000000      Original      
'* 
'***************************************************************************/

Imports Calib.OBReadLibNet.Api
Imports Calib.OBReadLibNet.Def
Imports Calib.SystemLibNet.Api
Imports Calib.SystemLibNet.Def

Public Class Form1

    Declare Function GetForegroundWindow Lib "coredll" () As IntPtr
    Dim HWND As IntPtr
    Dim thread As System.Threading.Thread

    'Barcode type
    Dim DecodeNum() As Integer = New Integer() { _
           OBR_NONDT, _
           OBR_CD39, _
           OBR_NW_7, _
           OBR_WPCA, _
           OBR_WPC, _
           OBR_UPEA, _
           OBR_UPE, _
           OBR_IDF, _
           OBR_ITF, _
           OBR_CD93, _
           OBR_CD128, _
           OBR_MSI, _
           OBR_IATA}

    Dim DecodeName() As String = New String() { _
           "          ", _
           "OBR_CD39  ", _
           "OBR_NW_7  ", _
           "OBR_WPCA  ", _
           "OBR_WPC   ", _
           "OBR_UPEA  ", _
           "OBR_UPE   ", _
           "OBR_IDF   ", _
           "OBR_ITF   ", _
           "OBR_CD93  ", _
           "OBR_CD128 ", _
           "OBR_MSI   ", _
           "OBR_IATA  "}

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim iRet As Integer

        HWND = GetForegroundWindow()
        iRet = OBRLoadConfigFile()              'ini File read default value set
        iRet = OBRSetDefaultSymbology()         '1D(OBR) driver mode will be ini File vallue
        iRet = OBRSetScanningKey(OBR_TRIGGERKEY_L Or OBR_TRIGGERKEY_R Or OBR_CENTERTRIGGER)
        iRet = OBRSetScanningCode(OBR_ALL)
        iRet = OBRSetBuffType(OBR_BUFOBR)   '1D(OBR) driver mode will be OBR_BUFOBR
        iRet = OBRSetScanningNotification(OBR_EVENT, IntPtr.Zero) '1D(OBR) driver mode will be OBR_EVENT
        iRet = OBROpen(HWND, 0)                 'OBRDRV open

        If (iRet = OBR_ERROR_INVALID_ACCESS) Then
            MessageBox.Show("Failed to connect to the scanner. Please exit a scanner application.", "OBRLibSampleCSWM")
            Exit Sub
        End If

        If (iRet = OBR_ERROR_HOTKEY) Then
            MessageBox.Show("Trigger keys are being used. Please quit the program which is using the trigger keys.", "OBRLibSampleCSWM")
            Exit Sub
        End If

        If (iRet <> OBR_OK) Then
            MessageBox.Show("Failed to connect to the scanner.", "OBRLibSampleCSWM")
            Exit Sub
        End If

        iRet = OBRClearBuff()
        thread = New System.Threading.Thread(New System.Threading.ThreadStart(AddressOf start))
        thread.Start()    'Start start thread
    End Sub

    Delegate Sub SetLabelText()

    Private Sub SetText()
        Dim leng As Integer    'digit number
        Dim leng2 As Byte      'digit number
        Dim dwrcd As Integer    'barcode type
        Dim ret As Integer
        Dim lcnt As Byte
        Dim buff(1024) As Byte
        Dim str As String
        Dim i As Integer


        If (IntPtr.op_Inequality(HWND, IntPtr.Zero)) Then
            'check OBRBuffer state
            ret = OBRGetStatus(leng, lcnt)
            If (leng <> 0) Then
                ' get OBRBuffer data
                ret = OBRGets(buff, dwrcd, leng2)
                Dim ASCII As System.Text.Encoding
                ASCII = System.Text.Encoding.GetEncoding("ascii")
                TextBox1.Text = ASCII.GetString(buff, 0, leng2)    'scan barcode type display

                str = "----------"
                For i = 0 To 12
                    If (DecodeNum(i) = dwrcd) Then
                        str = DecodeName(i)
                        Exit For
                    End If
                Next

                TextBox2.Text = str                 'scan barcode type display
                TextBox3.Text = leng2.ToString()    'digit number display
                TextBox4.Text = ret.ToString()      'end information display
            End If
            OBRClearBuff()
        End If

    End Sub

    Private Sub start()
        While (True)
            SysWaitForEvent(IntPtr.Zero, OBR_NAME_EVENT, INFINITE)    'Wait event
            Invoke(New SetLabelText(AddressOf SetText))    'Display OBRBuffer data
        End While

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        OBRClose()  'OBRDRV Close
        SysTerminateWaitEvent() 'End SysWaitForEvent function
        HWND = IntPtr.Zero
        TextBox1.Text = ""
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        thread.Abort()

        Me.Close()
    End Sub
End Class
