Imports System.Collections.Generic
Imports System.ComponentModel
'Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.IO
Imports CalibVb.Cp780LibVB.Api
Imports CalibVb.Cp780LibVB.Def

Public Class Form1
    <DllImport("Coredll.dll")> _
    Private Shared Function LineTo(ByVal hDC As Int32, ByVal nXEnd As Int32, ByVal nYEnd As Int32) As Boolean
    End Function
    <DllImport("Coredll.dll")> _
    Private Shared Function PeekMessage(ByRef lpMsg As MSG, ByVal hwnd As Int32, ByVal wMsgFilterMin As Int32, ByVal wMsgFilterMax As Int32, ByVal wRemoveMsg As Integer) As Boolean
    End Function

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure POINTAPI
        Public x As Integer
        Public y As Integer
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure MSG
        Public hWnd As IntPtr
        Public msg As Integer
        Public wParam As IntPtr
        Public lParam As IntPtr
        Public time As Integer
        Public pt As POINTAPI
    End Structure

    Private hPrinter As Int32 = 0
    Private hDC As Int32 = 0

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim bRet As Boolean = False

        ' CpOpenPrinter : Opens the specified printer and fetches the handle.
        ' Printer name : BuiltIn(the built-in printer) Output port name :
        ' BuiltIn(the built-in printer)
        bRet = CalibVB.Cp780LibVB.Api.CpOpenPrinter("BuiltIn", "BuiltIn", hPrinter)
        If bRet = False Then
            MessageBox.Show("CpOpenPrinter Error")
            Return
        End If

        Dim cInMode As New CalibVB.Cp780LibVB.CPDEVMODE()
        Dim cOutMode As New CalibVB.Cp780LibVB.CPDEVMODE()

        ' CpDocumentProperties : Fetches the printer data.
        ' Fetches the size required to store the printer data.
        Dim iSize As Int32 = CalibVB.Cp780LibVB.Api.CpDocumentProperties(CInt(Me.Handle), hPrinter, cOutMode, cInMode, CalibVB.Cp780LibVB.Def.CPDM_OUT_BUFFER)
        If iSize < 0 Then
            MessageBox.Show("CpDocumentProperties Error")
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            Return
        End If

        ' Changes the size (length) of drawing.
        ' Changes the drawing size (length) to 200(20[mm]).
        cOutMode.dmPaperLength = 200

        ' CpCreateDC : Fetches the device context handle for drawing.
        hDC = CalibVB.Cp780LibVB.Api.CpCreateDC(hPrinter, cOutMode)
        If hDC = 0 Then
            MessageBox.Show("CpCreateDC Error")
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            Return
        End If

        Dim cDocInfo As CalibVB.Cp780LibVB.CPDOCINFO = New CalibVB.Cp780LibVB.CPDOCINFO()
        cDocInfo.cbSize = 136

        ' CpSartDoc : Sets up for starting printing job.
        Dim iRet As Int32 = CalibVB.Cp780LibVB.Api.CpStartDoc(hPrinter, hDC, cDocInfo)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpStartDoc Error")
            Return
        End If

        ' CpStartPage : Sets up for starting the page.
        iRet = CalibVB.Cp780LibVB.Api.CpStartPage(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpStartPage Error")
            Return
        End If

        ' Draws a triangle on the device context handle
        LineTo(hDC, 100, 100)
        LineTo(hDC, 100, 0)
        LineTo(hDC, 0, 0)

        ' CpEndPage : Sets up for closing the page
        iRet = CalibVB.Cp780LibVB.Api.CpEndPage(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpEndPage Error")
            Return
        End If

        ' CpResetDC : Changes the paper size
        cOutMode.dmPaperLength = 100

        ' Changes the drawing size (length) from 200 to 100(10[mm]).
        Dim hDCOld As Int32 = hDC
        hDC = CalibVB.Cp780LibVB.Api.CpResetDC(hPrinter, hDC, cOutMode)
        If hDC = 0 Then
            MessageBox.Show("CpResetDC Error")
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDCOld)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDCOld)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            Return
        End If

        ' CpStartPage : Sets up for starting the page
        iRet = CalibVB.Cp780LibVB.Api.CpStartPage(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpStartPage Error")
            Return
        End If

        ' CpUnicodeOut : Sends the character string
        iRet = CalibVB.Cp780LibVB.Api.CpUnicodeOut(hPrinter, hDC, "UnicodeOut test", 15)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndPage(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpUnicodeOut Error")
            Return
        End If

        ' string szESC_E = "\x1b""E";
        Dim escdata As [Byte]() = New [Byte]() {&H1B, &H45, &H0}
        Dim dmydata As [Byte]() = New [Byte]() {&H0, &H0, &H0}

        ' CpExtEscape : Sends the command of [ESC]E (discharges non-print data)
        iRet = CalibVB.Cp780LibVB.Api.CpExtEscape(hPrinter, hDC, CalibVB.Cp780LibVB.Def.CPPASSTHROGH, 2, escdata(0), 0, _
         dmydata(0))

        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndPage(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpExtEscape Error")
            Return
        End If

        ' CpEndPage : Sets up for closing the page
        iRet = CalibVB.Cp780LibVB.Api.CpEndPage(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpEndPage Error")
            Return
        End If

        ' CpEndDoc : Sets up for closing the document
        ' Printing job starts when executing CpEndDoc function
        iRet = CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpEndDoc Error")
            Return
        End If

        ' CpDeleteDC : Deletes the device context
        bRet = CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
        If bRet = False Then
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpDeleteDC Error")
            Return
        End If

        ' CpClosePrinter : Closes the specified printer
        bRet = CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
        If bRet = False Then
            MessageBox.Show("CpClosePrinter Error")
            Return
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim bRet As Boolean = False
        Dim iRet As Int32

        ' CpOpenPrinter : Opens the specified printer and fetches the handle.
        ' Printer name : BuiltIn(the built-in printer) Output port name :
        ' BuiltIn(the built-in printer)
        bRet = CalibVB.Cp780LibVB.Api.CpOpenPrinter("BuiltIn", "BuiltIn", hPrinter)
        If bRet = False Then
            MessageBox.Show("CpOpenPrinter Error")
            Return
        End If

        ' CpSetBarcodeType:Specifies the method used to read the barcode on the back
        ' bartype = 1;					// Back-side barcode type 1
        ' bartype = 2;					// Back-side barcode type 2
        Dim bartype As Int32 = 2
        iRet = CalibVB.Cp780LibVB.Api.CpSetBarcodeType(hPrinter, bartype)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            MessageBox.Show("CpOpenPrinter Error")
            Return
        End If

        Dim cInMode As New CalibVB.Cp780LibVB.CPDEVMODE()
        Dim cOutMode As New CalibVB.Cp780LibVB.CPDEVMODE()

        ' CpDocumentProperties : Fetches the printer data
        ' Fetches the size required to store the printer data
        Dim iSize As Int32 = CalibVB.Cp780LibVB.Api.CpDocumentProperties(CInt(Me.Handle), hPrinter, cOutMode, cInMode, CalibVB.Cp780LibVB.Def.CPDM_OUT_BUFFER)
        If iSize < 0 Then
            MessageBox.Show("CpDocumentProperties Error")
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            Return
        End If

        ' Changing the drawing size (length)
        ' If reading the barcode on the back, set the drawing size (length) to at least 420 (42 [mm])
        cOutMode.dmPaperLength = 420
        cOutMode.bMarkerDetection = CalibVB.Cp780LibVB.Def.MARKER_END

        ' CpCreateDC : Fetches the device context handle for drawing
        hDC = CalibVB.Cp780LibVB.Api.CpCreateDC(hPrinter, cOutMode)
        If hDC = 0 Then
            MessageBox.Show("CpCreateDC Error")
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            Return
        End If

        Dim cDocInfo As CalibVB.Cp780LibVB.CPDOCINFO = New CalibVB.Cp780LibVB.CPDOCINFO()
        cDocInfo.cbSize = 136

        ' CpSartDoc : Sets up for starting printing job
        iRet = CalibVB.Cp780LibVB.Api.CpStartDoc(hPrinter, hDC, cDocInfo)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpStartDoc Error")
            Return
        End If

        ' CpStartPage : Sets up for starting the page
        iRet = CalibVB.Cp780LibVB.Api.CpStartPage(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpStartPage Error")
            Return
        End If

        ' Draws a triangle on the device context handle
        LineTo(hDC, 100, 100)
        LineTo(hDC, 100, 0)
        LineTo(hDC, 0, 0)

        ' CpEndPage : Sets up for closing the page
        iRet = CalibVB.Cp780LibVB.Api.CpEndPage(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpEndPage Error")
            Return
        End If

        ' CpEndDoc : Sets up for closing the document
        ' Printing job starts when executing CpEndDoc function
        iRet = CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
        If iRet = CalibVB.Cp780LibVB.Def.CP_ERROR Then
            CalibVB.Cp780LibVB.Api.CpEndDoc(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpEndDoc Error")
            Return
        End If

        ' CpDeleteDC : Deletes the device context
        bRet = CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
        If bRet = False Then
            CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
            CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
            MessageBox.Show("CpDeleteDC Error")
            Return
        End If

        ' Waits for printing to end, then reads in the results of the back-side barcode scan
        ' After receiving the CP_WM_PRINTDONE printing completion message,
        ' the system reads in the results of the back-side barcode scan.
        ' Carry out the following processes from within the window.
        While True
            Dim msg As New MSG()
            If PeekMessage(msg, 0, CalibVB.Cp780LibVB.Def.CP_WM_PRINTDONE, CalibVB.Cp780LibVB.Def.CP_WM_PRINTDONE, &H1) Then
                Dim len As Int32
                Dim szbarcode As String = "                                "
                len = 0

                If CalibVB.Cp780LibVB.Api.CpDecodeBarcode(hPrinter, len, szbarcode) > 0 Then
                    MessageBox.Show(szbarcode)
                Else
                    MessageBox.Show("CpDecodeBarcode Error")
                End If
                Exit While
            End If
            System.Threading.Thread.Sleep(100)
        End While

        ' CpClosePrinter : Closes the specified printer
        bRet = CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
        If bRet = False Then
            MessageBox.Show("CpClosePrinter Error")
            Return
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        CalibVB.Cp780LibVB.Api.CpDeleteDC(hPrinter, hDC)
        CalibVB.Cp780LibVB.Api.CpClosePrinter(hPrinter)
        Application.[Exit]()
    End Sub
End Class
