#include "stdafx.h"
#include "PrinGDILibSampleVC.h"
#include <windows.h>
#include <commctrl.h>
#include <CpLib.h>
#include <CpExtDvm.h>

#define MAX_LOADSTRING 100

#define IDC_BTN_PRINT_TRIANGLE	1001
#define IDC_BTN_READ_BARCODE	1002

#define MES_TITLE			_T("Print GDI Library Sample Program")
#define MES_BTN_PRINT_E		_T("Print the sample data")
#define MES_BTN_PRINT_J		_T("Tvf[^")
#define MES_BTN_BARCODE_E	_T("Read the barcode")
#define MES_BTN_BARCODE_J	_T("ʃo[R[hǂݎ")

HINSTANCE			g_hInst;
#ifdef SHELL_AYGSHELL
HWND				g_hWndMenuBar;
#else // SHELL_AYGSHELL
HWND				g_hWndCommandBar;
#endif // SHELL_AYGSHELL

ATOM				MyRegisterClass(HINSTANCE, LPTSTR);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

void PrintSample( HWND);
void PrintAndReadBarcodeSample( HWND);

int WINAPI WinMain(HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;

	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_PRINGDILIBSAMPLEVC));

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_PRINGDILIBSAMPLEVC));
	wc.hCursor       = 0;
#ifdef SHELL_AYGSHELL
	wc.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH);
#else
	wc.hbrBackground = (HBRUSH) GetStockObject( LTGRAY_BRUSH);
#endif	// SHELL_AYGSHELL
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
	TCHAR szTitle[MAX_LOADSTRING];
	TCHAR szWindowClass[MAX_LOADSTRING];

	g_hInst = hInstance;

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
	SHInitExtraControls();
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
	LoadString(hInstance, IDC_PRINGDILIBSAMPLEVC, szWindowClass, MAX_LOADSTRING);

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP

	if (!MyRegisterClass(hInstance, szWindowClass))
	{
		return FALSE;
	}

	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}

#ifdef WIN32_PLATFORM_PSPC
	if (g_hWndMenuBar)
	{
		RECT rc;
		RECT rcMenuBar;

		GetWindowRect(hWnd, &rc);
		GetWindowRect(g_hWndMenuBar, &rcMenuBar);
		rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);

		MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
	}
#endif // WIN32_PLATFORM_PSPC

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

#ifndef SHELL_AYGSHELL
	if (g_hWndCommandBar)
	{
		CommandBar_Show(g_hWndCommandBar, TRUE);
	}
#endif // !SHELL_AYGSHELL

	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
	static SHACTIVATEINFO s_sai;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		switch (wmId)
		{
		case IDC_BTN_PRINT_TRIANGLE:
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_PRINT_TRIANGLE), FALSE);
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_READ_BARCODE), FALSE);
			PrintSample( hWnd);
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_PRINT_TRIANGLE), TRUE);
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_READ_BARCODE), TRUE);
			break;
		case IDC_BTN_READ_BARCODE:
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_READ_BARCODE), FALSE);
			PrintAndReadBarcodeSample( hWnd);
			EnableWindow( GetDlgItem( hWnd, IDC_BTN_READ_BARCODE), TRUE);
			break;
		case IDM_HELP_ABOUT:
			DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
			break;
#ifndef SHELL_AYGSHELL
		case IDM_FILE_EXIT:
			DestroyWindow(hWnd);
			break;
#endif // !SHELL_AYGSHELL
#ifdef WIN32_PLATFORM_PSPC
		case IDM_OK:
			SendMessage (hWnd, WM_CLOSE, 0, 0);
			break;
#endif // WIN32_PLATFORM_PSPC
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_CREATE:
#ifndef SHELL_AYGSHELL
		g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
		CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
		CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		SHMENUBARINFO mbi;

		memset(&mbi, 0, sizeof(SHMENUBARINFO));
		mbi.cbSize     = sizeof(SHMENUBARINFO);
		mbi.hwndParent = hWnd;
		mbi.nToolBarId = IDR_MENU;
		mbi.hInstRes   = g_hInst;

		if (!SHCreateMenuBar(&mbi)) 
		{
			g_hWndMenuBar = NULL;
		}
		else
		{
			g_hWndMenuBar = mbi.hwndMB;
		}

		memset(&s_sai, 0, sizeof (s_sai));
		s_sai.cbSize = sizeof (s_sai);
#endif // SHELL_AYGSHELL

//		TCHAR szMes1[ 128] = { 0}, szMes2[ 128] = { 0};
		TCHAR szMes1[ 128], szMes2[ 128];
		if ( LOWORD( GetKeyboardLayout( 0)) == 0x0411)
		{
			wcscpy( szMes1, MES_BTN_PRINT_J);
		}
		else
		{
			wcscpy( szMes1, MES_BTN_PRINT_E);
		}
		if ( LOWORD( GetKeyboardLayout( 0)) == 0x0411)
		{
			wcscpy( szMes2, MES_BTN_BARCODE_J);
		}
		else
		{
			wcscpy( szMes2, MES_BTN_BARCODE_E);
		}

#ifdef SHELL_AYGSHELL
		CreateWindow( _T("static"), MES_TITLE,
			WS_CHILD | WS_VISIBLE,
			40,  20, 400,  40, hWnd, NULL, g_hInst, NULL);
		CreateWindow( TEXT("button"), szMes1,
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			40, 120, 400, 60, hWnd, ( HMENU)IDC_BTN_PRINT_TRIANGLE, g_hInst, NULL);
		CreateWindow( TEXT("button"), szMes2,
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			40, 200, 400, 60, hWnd, ( HMENU)IDC_BTN_READ_BARCODE, g_hInst, NULL);
#else
		CreateWindow( _T("static"), MES_TITLE,
			WS_CHILD | WS_VISIBLE,
			20,  30, 200,  20, hWnd, NULL, g_hInst, NULL);
		CreateWindow( TEXT("button"), szMes1,
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			20,  60, 200, 30, hWnd, ( HMENU)IDC_BTN_PRINT_TRIANGLE, g_hInst, NULL);
		CreateWindow( TEXT("button"), szMes2,
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			20, 100, 200, 30, hWnd, ( HMENU)IDC_BTN_READ_BARCODE, g_hInst, NULL);
#endif // SHELL_AYGSHELL

		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);

		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
#ifndef SHELL_AYGSHELL
		CommandBar_Destroy(g_hWndCommandBar);
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		CommandBar_Destroy(g_hWndMenuBar);
#endif // SHELL_AYGSHELL
		PostQuitMessage(0);
		break;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
	case WM_ACTIVATE:
		SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
		break;
	case WM_SETTINGCHANGE:
		SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
		break;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
#ifndef SHELL_AYGSHELL
		RECT rectChild, rectParent;
		int DlgWidth, DlgHeight;
		int NewPosX, NewPosY;

		if (GetWindowRect(hDlg, &rectChild)) 
		{
			GetClientRect(GetParent(hDlg), &rectParent);
			DlgWidth	= rectChild.right - rectChild.left;
			DlgHeight	= rectChild.bottom - rectChild.top ;
			NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
			NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;

			if (NewPosX < 0) NewPosX = 0;
			if (NewPosY < 0) NewPosY = 0;
			SetWindowPos(hDlg, 0, NewPosX, NewPosY,
				0, 0, SWP_NOZORDER | SWP_NOSIZE);
		}
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		{
			SHINITDLGINFO shidi;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
		}
#endif // SHELL_AYGSHELL

		return (INT_PTR)TRUE;

	case WM_COMMAND:
#ifndef SHELL_AYGSHELL
		if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		if (LOWORD(wParam) == IDOK)
#endif
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;

	case WM_CLOSE:
		EndDialog(hDlg, message);
		return (INT_PTR)TRUE;

	}
	return (INT_PTR)FALSE;
}


///////////////////////////////////////////////////////////////
// Print a triangle and string
///////////////////////////////////////////////////////////////
TCHAR szUni[] = _T("UnicodeOut test");
char szESC_E[] = "\x1b""E";

void PrintSample( HWND hWnd)			// hWnd the window handle of the application
{
	HANDLE hPrinter;
	HDC hDC, hDCOld;
	LPCPDEVMODE pInCDM = NULL;			// Input value of printer data
	LPCPDEVMODE pCDM = NULL;			// Area of printer data
	CPDOCINFO doc;
	int fMode = CPDM_OUT_BUFFER;		// Output request of printer data
	int size;

	/***** CpOpenPrinter : Opens the specified printer and fetches the handle. *****/
	// Printer name : BuiltIn(the built-in printer) Output port name :
	// BuiltIn(the built-in printer)
	if (CpOpenPrinter(_T("BuiltIn"), _T("BuiltIn"), &hPrinter) != TRUE)
	{
		return;
	}

	/***** CpDocumentProperties : Fetches the printer data. *****/
	// Fetches the size required to store the printer data.
	size = CpDocumentProperties(hWnd, hPrinter, pCDM, pInCDM, fMode);
	if (size < 0)
	{
		CpClosePrinter(hPrinter);
		return;
	}

	// Secure the area for the necessary size fetched.
	pCDM = (LPCPDEVMODE)malloc(size);

	// Fetches the default information about CPDEVMODE.
	if (CpDocumentProperties(hWnd, hPrinter, pCDM, pInCDM, fMode) < 0)
	{
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** Changes the size (length) of drawing. *****/
	// Changes the drawing size (length) to 200(20[mm]).
	pCDM->dmPaperLength = 200;

	// The length can be directly specified as shown above without using
	// the method by changing the property CPDM_IN_PROMPT of gfModeh
	// parameter of CpDocumentProperties function.

	/***** In case the expanded information for individual printer model is changed. *****/
	// Include the header file (gCpExtDvm.hh) for the printer expanded
	// information definition.
	// In case printing speed of the built-in printer is changed to
	// gHigh speedh.
	// ((LPCPCDEVMODE)pCDM)->dlg.PrintSpeed = PRINTSPEED_FAST;

	/***** CpCreateDC : Fetches the device context handle for drawing. *****/
	hDC = CpCreateDC(hPrinter, pCDM);
	if (hDC == NULL)
	{
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpSartDoc : Sets up for starting printing job. *****/
	// CPDOCINFO setting
	doc.cbSize = sizeof(CPDOCINFO);
	wcscpy((LPWSTR)doc.DocName, (LPWSTR)_T("Document name"));
	wcscpy((LPWSTR)doc.Output, (LPWSTR)_T(""));
	if (CpStartDoc(hPrinter, hDC, &doc) == CP_ERROR)
	{
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpStartPage : Sets up for starting the page. *****/
	if (CpStartPage(hPrinter, hDC) == CP_ERROR)
	{
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** Image drawing : The image as shown below is being drawn to the device context handle. *****/
	LineTo(hDC, 100, 100);
	LineTo(hDC, 100, 0);
	LineTo(hDC, 0, 0);

	/***** CpEndPage : Sets up for closing the page.*****/
	if (CpEndPage(hPrinter, hDC) == CP_ERROR)
	{
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpResetDC : Changes the paper size.*****/
	hDCOld = hDC;
	pCDM->dmPaperLength = 100;

	// Changes the drawing size (length) from 200 to 100(10[mm]).
	hDC = CpResetDC(hPrinter, hDC, pCDM);
	if (hDC == NULL)
	{
		CpEndDoc(hPrinter, hDCOld);
		CpDeleteDC(hPrinter, hDCOld);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpStartPage : Sets up for starting the page *****/
	if (CpStartPage(hPrinter, hDC) == CP_ERROR)
	{
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpUnicodeOut : Sends the character string.*****/
	if (CpUnicodeOut(hPrinter, hDC, szUni, lstrlen(szUni)) == CP_ERROR)
	{
		CpEndPage(hPrinter, hDC);
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpExtEscape : Sends the command of [ESC]E (discharges non-print data). *****/
	if (CpExtEscape(hPrinter, hDC, CPPASSTHROGH, (int)sizeof(szESC_E),
		(LPCSTR)szESC_E, 0, NULL) == CP_ERROR)
	{
		CpEndPage(hPrinter, hDC);
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpEndPage : Sets up for closing the page. *****/
	if (CpEndPage(hPrinter, hDC) == CP_ERROR)
	{
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpEndDoc : Sets up for closing the document. *****/
	// Printing job starts when executing CpEndDoc function.
	if (CpEndDoc(hPrinter, hDC) == CP_ERROR)
	{
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpDeleteDC : Deletes the device context. *****/
	if (CpDeleteDC(hPrinter, hDC) != TRUE)
	{
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/***** CpClosePrinter : Closes the specified printer. *****/
	if (CpClosePrinter(hPrinter) != TRUE)
	{
		free(pCDM);
		return;
	}
	// Release the storage area for the printer data.
	if(pCDM)
	{
		free(pCDM);
	}
}


///////////////////////////////////////////////////////////////
// Read a barcode and Print a triangle and string
///////////////////////////////////////////////////////////////
void PrintAndReadBarcodeSample(HWND hWnd)
{
	HANDLE hPrinter;
	HDC hDC;
	LPCPDEVMODE pInCDM = NULL;			// Printer data input value
	LPCPDEVMODE pCDM = NULL;			// Printer data area
	CPDOCINFO doc;
	int fMode = CPDM_OUT_BUFFER;		// Printer data output request
	int size;
	DWORD dwBarType;

	/* CpOpenPrinter:Opens the specified printer and gets the handle */
	// Printer name:BuiltIn(internal printer)
	// Output port name:BuiltIn(internal printer)
	if (CpOpenPrinter(_T("BuiltIn"), _T("BuiltIn"), &hPrinter) != TRUE)
	{
		return;
	}

	/* CpSetBarcodeType:Specifies the method used to read the barcode on the back */
	// dwBarType = 1;					// Back-side barcode type 1
	dwBarType = 2;						// Back-side barcode type 2
	CpSetBarcodeType( hPrinter, dwBarType);

	/* CpDocumentProperties:Gets the printer data */
	// Gets sufficient space needed to store the printer data
	size = CpDocumentProperties(hWnd, hPrinter, pCDM, pInCDM, fMode);
	if (size < 0)
	{
		CpClosePrinter(hPrinter);
		return;
	}

	// Ensures that a space equivalent to the necessary space has been obtained
	pCDM = (LPCPDEVMODE)malloc(size);

	// Gets the CPDEVMODE default data
	if (CpDocumentProperties(hWnd, hPrinter, pCDM, pInCDM, fMode) < 0)
	{
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* Changing the drawing size (length) */
	// If reading the barcode on the back, set the drawing size (length) to at least 420 (42 [mm])
	pCDM->dmPaperLength = 420;

	/* When reading the barcode on the back, set the mark detection setting to "Mark detection (terminal)" */
	((LPCPCDEVMODE)pCDM)->dlg.bMarkerDetection = MARKER_END;

	/* CpCreateDC: gets the device context handle for drawing */
	hDC = CpCreateDC(hPrinter, pCDM);
	if (hDC == NULL)
	{
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* CpSartDoc: sets the start of the print document */
	// CPDOCINFO Setting
	doc.cbSize = sizeof(CPDOCINFO);
	wcscpy((LPWSTR)doc.DocName, (LPWSTR)_T("Document name"));
	wcscpy((LPWSTR)doc.Output, (LPWSTR)_T(""));
	if (CpStartDoc(hPrinter, hDC, &doc) == CP_ERROR)
	{
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* CpStartPage:Sets the start of the page */
	if (CpStartPage(hPrinter, hDC) == CP_ERROR)
	{
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* Draw image: Draws the image shown to the right on the device context handle */
	LineTo(hDC, 100, 100);
	LineTo(hDC, 100, 0);
	LineTo(hDC, 0, 0);

	/* CpEndPage: Sets the end of the page */
	if (CpEndPage(hPrinter, hDC) == CP_ERROR)
	{
		CpEndDoc(hPrinter, hDC);
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* CpEndDoc:Sets the end of the document */
	// Running CpEndDoc starts the printing.
	if (CpEndDoc(hPrinter, hDC) == CP_ERROR)
	{
		CpDeleteDC(hPrinter, hDC);
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* CpDeleteDC:Delets the device context */
	if (CpDeleteDC(hPrinter, hDC) != TRUE)
	{
		CpClosePrinter(hPrinter);
		free(pCDM);
		return;
	}

	/* Waits for printing to end, then reads in the results of the back-side barcode scan */
	// After receiving the CP_WM_PRINTDONE printing completion message,
	// the system reads in the results of the back-side barcode scan.
	// Carry out the following processes from within the window.
	DWORD tick = GetTickCount();
	while(( GetTickCount() - tick) < 10000)
	{
		MSG winmsg;
		if ( PeekMessage( &winmsg, hWnd, CP_WM_PRINTDONE, CP_WM_PRINTDONE, PM_REMOVE))
		{
			DWORD len;
			TCHAR szbarcode[ 32], szmes[ 64];
			len = 0;
			ZeroMemory( szbarcode, sizeof( szbarcode));
			if ( CpDecodeBarcode( hPrinter, &len, szbarcode) > 0)
			{
				wsprintf( szmes, L"len=%u\r\n%s", len, szbarcode);
				MessageBox( hWnd, szmes, L"Barcode", MB_OK);
			}
			break;
		}
		Sleep( 100);
	}

	/* CpClosePrinter:Closes the designated printer */
	if (CpClosePrinter(hPrinter) != TRUE)
	{
		free(pCDM);
		return;
	}

	// Releases the printer data storage space
	if(pCDM)
	{
		free(pCDM);
	}
}
