Public Class Form1
    Inherits System.Windows.Forms.Form
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents Button3 As System.Windows.Forms.Button

#Region " Windows Form Designer generated code "

    Public Sub New()

        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.Button1 = New System.Windows.Forms.Button
        Me.Button2 = New System.Windows.Forms.Button
        Me.Button3 = New System.Windows.Forms.Button
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(24, 24)
        Me.Button1.Size = New System.Drawing.Size(192, 32)
        Me.Button1.Text = "Print Character"
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(24, 72)
        Me.Button2.Size = New System.Drawing.Size(192, 32)
        Me.Button2.Text = "Print Graphic"
        '
        'Button3
        '
        Me.Button3.Location = New System.Drawing.Point(24, 120)
        Me.Button3.Size = New System.Drawing.Size(192, 32)
        Me.Button3.Text = "Print Screen"
        '
        'Form1
        '
        Me.ClientSize = New System.Drawing.Size(242, 271)
        Me.Controls.Add(Me.Button3)
        Me.Controls.Add(Me.Button2)
        Me.Controls.Add(Me.Button1)
        Me.Text = "PrnLibSampleVB"

    End Sub

    Public Shared Sub Main()
        Application.Run(New Form1())
    End Sub

#End Region

    ' CASIO printer library declaration
    Dim Api As New Calib.PrinterLibNet.Api
    Dim Def As New Calib.PrinterLibNet.Def

    Dim strInputCharANK() As Char = New Char() {Chr(27), "Y"c, Chr(1)}
    ' This is ESC code : Input Character code select
    ' Format is ESC Y n
    '					n : 00h(Unicode), 01h(ANK 0020h - 00FFh)

    Dim strBuff() As Char = New Char() {Chr(32)}
    Dim strCR() As Char = New Char() {Chr(13)}  ' Set Carriage Return code

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim nRet As Integer
        Dim i As Integer
        Dim dwPaperType As Integer = New Integer
        Dim dwDepth As Integer = New Integer
        Dim dwSpeed As Integer = New Integer
        Dim dwAutoloading As Integer = New Integer
        Dim dwLoadingValue As Integer = New Integer
        Dim dwPreHeat As Integer = New Integer
        Dim dwPrintContinuation As Integer = New Integer

        'open printer driver
        nRet = Api.PRNOpen()
        If (nRet <> Def.PRN_NORMAL) Then
            ShowErrorMessage("PRNOpen", nRet)
            Exit Sub
        End If

        'check printer state
        nRet = Api.PRNGetPrinterProperty(dwPaperType, dwDepth, dwSpeed, dwAutoloading, dwLoadingValue, dwPreHeat, dwPrintContinuation)
        If (nRet <> Def.PRN_NORMAL) Then
            ShowErrorMessage("PRNGetPrinterProperty", nRet)
            Exit Sub
        End If

        'print out character code
        nRet = Api.PRNTextOut(0, "PrinterLibNet Sample-PRNTextOut\n\n")
        ShowErrorMessage("PRNTextOut", nRet)

        Api.PRNTextOut(3, strInputCharANK) ' Select ANK input character code
        For i = 32 To 255 ' print out from 20h to FFh ANK code
            strBuff(0) = ChrW(i)
            nRet = Api.PRNTextOut(1, strBuff)
            ShowErrorMessage("PRNTextOut", nRet)
        Next

        'print out carriage return
        nRet = Api.PRNTextOut(1, strCR)

        'close printer driver
        nRet = Api.PRNClose()
        ShowErrorMessage("PRNClose", nRet)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim nRet As Integer
        Dim i As Integer
        Dim ByteWorkBuf1(72 * 10) As Byte
        Dim dwPaperType As Integer = New Integer
        Dim dwDepth As Integer = New Integer
        Dim dwSpeed As Integer = New Integer
        Dim dwAutoloading As Integer = New Integer
        Dim dwLoadingValue As Integer = New Integer
        Dim dwPreHeat As Integer = New Integer
        Dim dwPrintContinuation As Integer = New Integer

        'open printer driver
        nRet = Api.PRNOpen()
        If (nRet <> Def.PRN_NORMAL) Then
            ShowErrorMessage("PRNOpen", nRet)
            Exit Sub
        End If

        'check printer state
        nRet = Api.PRNGetPrinterProperty(dwPaperType, dwDepth, dwSpeed, dwAutoloading, dwLoadingValue, dwPreHeat, dwPrintContinuation)
        If (nRet <> Def.PRN_NORMAL) Then
            ShowErrorMessage("PRNGetPrinterProperty", nRet)
            Exit Sub
        End If

        For i = 0 To ByteWorkBuf1.Length - 1
            ByteWorkBuf1(i) = &HFF
        Next

        'print out a black quadrangle
        nRet = Api.PRNImageOut(72, 10, 0, ByteWorkBuf1)
        ShowErrorMessage("PRNImageOut", nRet)

        'print out carriage return
        Api.PRNTextOut(1, strCR)

        'print out a bitmap image
        nRet = Api.PRNBMPOut("\Windows\BITMAP.bmp")
        ShowErrorMessage("PRNBMPOut", nRet)

        Api.PRNTextOut(1, strCR)
        'close printer driver
        nRet = Api.PRNClose()
        ShowErrorMessage("PRNClose", nRet)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim nRet As Integer
        Dim i As Integer
        Dim dwPaperType As Integer = New Integer
        Dim dwDepth As Integer = New Integer
        Dim dwSpeed As Integer = New Integer
        Dim dwAutoloading As Integer = New Integer
        Dim dwLoadingValue As Integer = New Integer
        Dim dwPreHeat As Integer = New Integer
        Dim dwPrintContinuation As Integer = New Integer

        'open printer driver
        nRet = Api.PRNOpen()
        If (nRet <> Def.PRN_NORMAL) Then
            ShowErrorMessage("PRNOpen", nRet)
            Exit Sub
        End If

        'check printer state
        nRet = Api.PRNGetPrinterProperty(dwPaperType, dwDepth, dwSpeed, dwAutoloading, dwLoadingValue, dwPreHeat, dwPrintContinuation)
        If (nRet <> Def.PRN_NORMAL) Then
            ShowErrorMessage("PRNGetPrinterProperty", nRet)
            Exit Sub
        End If

        'print out display screen
        nRet = Api.PRNPrintScreen()
        ShowErrorMessage("PRNPrintScreen", nRet)

        Api.PRNTextOut(1, strCR)
        'close printer driver
        nRet = Api.PRNClose()
        ShowErrorMessage("PRNClose", nRet)
    End Sub

    Private Sub ShowErrorMessage(ByVal pszCaption As String, ByVal nStatus As Int32)

        Dim szTitle As String = "PrinterLib Sample for VB"
        Dim szMsg As String

        'error message
        Select Case nStatus
            Case Def.PRN_NORMAL
                Exit Sub

            Case Def.PRN_NOTOPEN
                szMsg = "PRN_NOTOPEN"

            Case Def.PRN_DRIVER_NOTEXIST
                szMsg = "PRN_DRIVER_NOTEXIST"

            Case Def.PRN_ALREADY_OPEN
                szMsg = "PRN_ALREADY_OPEN"

            Case Def.PRN_NOTFOUND
                szMsg = "PRN_NOTFOUND"

            Case Def.PRN_NOTCHANGE
                szMsg = "PRN_NOTCHANGE"

            Case Def.PRN_FILE_NOTEXIST
                szMsg = "PRN_FILE_NOTEXIST"

            Case Def.PRN_FILEFORMAT_ERROR
                szMsg = "PRN_FILEFORMAT_ERROR"

            Case Def.PRN_FILEOPEN_ERROR
                szMsg = "PRN_FILEOPEN_ERROR"

            Case Def.PRN_PARAMETER_ERROR
                szMsg = "PRN_PARAMETER_ERROR"

            Case Def.PRN_HARDWARE_ERROR
                szMsg = "PRN_HARDWARE_ERROR"

            Case Def.PRN_PLATEN_OPEN
                szMsg = "PRN_PLATEN_OPEN"

            Case Def.PRN_PAPER_END
                szMsg = "PRN_PAPER_END"

            Case Def.PRN_AUTOLOADING
                szMsg = "PRN_AUTOLOADING"

            Case Def.FUNCTION_UNSUPPORT
                szMsg = "FUNCTION_UNSUPPORT"

            Case Else
                szMsg = "Unknown Status"
        End Select

        ' display messagebox
        MessageBox.Show(szMsg, szTitle)
    End Sub
End Class
