/******************************************************************************
*  PrnLibSampleVC.cpp                                                                *
*                                                                             *
*  Project : Printer Demo Application for DT-9700/IT-3000                     *
*  Date    : 2004-03-05                                                       *
*  Version : 1.0.0                                                            *
*                                                                             *
*  Copyright (C) 2004, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
*                                                                             *
******************************************************************************/
#include "PrinterLibSampleVC.h"


HINSTANCE	g_hInst;
HWND		hwndCB;
HMENU		g_menuPop=NULL;
static NOTIFYICONDATA m_nid;

//------------------------------------------------------------------------------------
//		PROTOTYPE DECLARATION
//------------------------------------------------------------------------------------
ATOM MyRegisterClass(HINSTANCE, LPTSTR);
BOOL InitInstance(HINSTANCE, int);
void AddSystemTrayIcon(HWND hWnd);
BOOL DuplicatActivation();

//-------------------------------------------------------------
//		WinMain
//-------------------------------------------------------------
int WINAPI WinMain(	HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine, int       nCmdShow)
{
	MSG msg;
	if( DuplicatActivation()== TRUE)
	{
		return FALSE;
	}
	
	InitCommonControls(); 
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}


//-------------------------------------------------------------
//		MyRegisterClass
//-------------------------------------------------------------
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC) WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_PRNDEMO));
	wc.hCursor			= 0;
	wc.hbrBackground	= (HBRUSH) GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName		= 0;
	wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//-------------------------------------------------------------
//		InitInstance
//-------------------------------------------------------------
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;

	g_hInst = hInstance;

	MyRegisterClass(hInstance, (LPTSTR)c_szAPNAME);

	hWnd = CreateWindow(c_szAPNAME, c_szAPNAME, 
				WS_SYSMENU|WS_OVERLAPPED|WS_MINIMIZEBOX,
				CW_USEDEFAULT, 
				CW_USEDEFAULT, 
				240, 320, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{	
		return FALSE;
	}

	SendMessage( hWnd, WM_SETICON, FALSE,
		(LPARAM)LoadImage(hInstance, MAKEINTRESOURCE(IDI_PRNDEMO), IMAGE_ICON, 16, 16, 0) );

	ShowWindow(hWnd, SW_SHOW);

	UpdateWindow(hWnd);

	if (hwndCB)
	{
		CommandBar_Show(hwndCB, TRUE);
	}

	return TRUE;
}

//-------------------------------------------------------------
//		WndProc
//-------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	int		nResult;
	TCHAR buff[256];	
	static int PrintScreenExec=FALSE;

	switch (message) 
	{
		case WM_CREATE:
			hwndCB = CommandBar_Create(g_hInst, hWnd, 1);
			CommandBar_InsertMenubar(hwndCB, g_hInst, IDM_MENU, 0);

			CreateWindow(_T("BUTTON"), c_szFORMS, 
				BS_DEFPUSHBUTTON  | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
				15,35,210,38, hWnd, (HMENU)IDC_BUTTON_TEXT , g_hInst, NULL);

			CreateWindow(_T("BUTTON"), c_szGRAPHIC, 
				BS_PUSHBUTTON | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
				15,82,210,38, hWnd, (HMENU)IDC_BUTTON_GRAPHIC , g_hInst, NULL);
		
			CreateWindow(_T("BUTTON"), c_szSCREEN, 
				BS_PUSHBUTTON | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
				15,129,210,38, hWnd, (HMENU)IDC_BUTTON_SCREEN , g_hInst, NULL);

			CreateWindow(_T("BUTTON"), c_szSTAMP, 
				BS_PUSHBUTTON | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
				15,176,210,38, hWnd, (HMENU)IDC_BUTTON_STAMP , g_hInst, NULL);

			CreateWindow(_T("BUTTON"), c_szEXTCHAR, 
				BS_PUSHBUTTON | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
				15,223,210,38, hWnd, (HMENU)IDC_BUTTON_USERDEF , g_hInst, NULL);
			break;
	
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
				case IDC_BUTTON_TEXT:
					TextPrint(hWnd);
					break;

				case IDC_BUTTON_GRAPHIC:
					nResult  = DialogBox( g_hInst, MAKEINTRESOURCE(IDD_DIALOG_GRAPHIC),
											hWnd,(DLGPROC)GraphicWndProc); 
					if(nResult ==-1)
					{
						wsprintf(buff,TEXT("CreateDialog Error:%d\n"),GetLastError());
						MessageBox(hWnd,  buff,(LPCTSTR)"",	MB_OK);
						return FALSE;
					}
					break;

				case IDC_BUTTON_SCREEN:
					PrintScreenExec=TRUE;;
					ScreenPrint(hWnd);
					PrintScreenExec=FALSE;;
					break;

				case IDC_BUTTON_STAMP:
					nResult  = DialogBox( g_hInst, MAKEINTRESOURCE(IDD_DIALOG_STAMP),
											hWnd,(DLGPROC)StampWndProc); 
					if(nResult ==-1)
					{
						wsprintf(buff,TEXT("CreateDialog Error:%d\n"),GetLastError());
						MessageBox(hWnd,  buff,(LPCTSTR)"",	MB_OK);
						return FALSE;
					}
					break;

				case IDC_BUTTON_USERDEF:
					nResult  = DialogBox( g_hInst, MAKEINTRESOURCE(IDD_DIALOG_EXTCHARA),
											hWnd,(DLGPROC)ExtCharWndProc); 
					if(nResult == -1)
					{
						wsprintf(buff,TEXT("CreateDialog Error:%d\n"),GetLastError());
						MessageBox(hWnd,  buff,(LPCTSTR)"",	MB_OK);
						return FALSE;
					}
					break;
				case IDM_MAXWINDOW:
					SendMessage(hWnd, WM_SIZE, SIZE_MAXIMIZED, 0L);
					break;

				case IDM_FILE_EXIT:
				case  IDM_EXIT:
					SendMessage(hWnd, WM_DESTROY, 0, 0L);
					break;

				case IDM_HELP_ABOUT:
				   DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;

				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_TRAY:
			{
				if(wParam == TRAY_ID) 
				{
					if((lParam == WM_LBUTTONDOWN) 
						&& (g_menuPop==NULL) 
							&& (PrintScreenExec==FALSE)) 
					{

						POINT point;

						g_menuPop = CreatePopupMenu();
						AppendMenu(g_menuPop, MF_STRING, IDM_MAXWINDOW, c_szMAXWINDOW);
						AppendMenu(g_menuPop, MF_STRING, IDC_BUTTON_SCREEN, c_szSCREEN);
						AppendMenu(g_menuPop, MF_STRING, IDM_EXIT, c_szEXIT);
						SetForegroundWindow(hWnd);

						point.x=GetSystemMetrics(SM_CXSCREEN); 
						point.y=GetSystemMetrics(SM_CYSCREEN);

						TrackPopupMenu(g_menuPop, TPM_LEFTALIGN |TPM_TOPALIGN| TPM_NONOTIFY , 
							point.x, point.y, 
							0, hWnd, 
							NULL);

						DestroyMenu(g_menuPop);
						g_menuPop=NULL;
					}
				}
			}
			break;

		case WM_SIZE:
			if(wParam==	SIZE_MINIMIZED)
			{
				ShowWindow(hWnd, SW_HIDE);
				AddSystemTrayIcon(hWnd);
			}
			else if(wParam==SIZE_MAXIMIZED)
			{
				Shell_NotifyIcon(NIM_DELETE, &m_nid);
				ShowWindow(hWnd, SW_SHOWMAXIMIZED);
			}
			break;

		case WM_DESTROY:
			Shell_NotifyIcon(NIM_DELETE, &m_nid);
			CommandBar_Destroy(hwndCB);
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//------------------------------------------------------------------------------------
//		About
//------------------------------------------------------------------------------------
LRESULT CALLBACK About(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;
	int NewPosX, NewPosY;
	switch (message)
	{
		case WM_INITDIALOG:
			if (GetWindowRect(hWnd, &rt1)) 
			{
				GetClientRect(GetParent(hWnd), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;

				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hWnd, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return TRUE;

		case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
			{
				EndDialog(hWnd, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

//-------------------------------------------------------------
//		DuplicatActivation 
//-------------------------------------------------------------
BOOL DuplicatActivation()
{
	HWND hWnd;
	hWnd = FindWindow(c_szAPNAME, c_szAPNAME);
	if(hWnd != NULL) 
	{
		SetForegroundWindow(hWnd);
		return TRUE;
	}
	return FALSE;
}

//-------------------------------------------------------------
//		AddSystemTrayIcon 
//-------------------------------------------------------------
void AddSystemTrayIcon(HWND hWnd)
{
	HICON hIcon;
	ZeroMemory(&m_nid, sizeof(NOTIFYICONDATA));
	m_nid.cbSize			= sizeof(NOTIFYICONDATA);
	m_nid.hWnd				= hWnd;
	m_nid.uID				= TRAY_ID;
	m_nid.uFlags			= NIF_ICON | NIF_MESSAGE | NIF_TIP;
	m_nid.uCallbackMessage	= WM_TRAY;
	hIcon					= (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(IDI_PRNDEMO),
									IMAGE_ICON, 16, 16, 0 );
	m_nid.hIcon				= hIcon;
	lstrcpy(m_nid.szTip, c_szAPNAME);
	Shell_NotifyIcon(NIM_ADD, &m_nid);
}
//----------------------End Of File------------------------------------------
