/******************************************************************************
*  prnGraphic.cpp                                                             *
*                                                                             *
*  Project : Printer Demo Application for DT-9700/IT-3000                     *
*  Date    : 2004-03-05                                                       *
*  Version : 1.0.0                                                            *
*                                                                             *
*  Copyright (C) 2004, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
*                                                                             *
******************************************************************************/
#include    "PrinterLibSampleVC.h"


//-------------------------------------------------------------
//		GraphicWndProc
//-------------------------------------------------------------
LRESULT CALLBACK WINAPI	GraphicWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{	
	RECT rc;
	int x, y,nWidth, nHeight; 
	int resourceId=IDB_GRAPHIC_S;;
	switch (message) 
	{ 
		case WM_INITDIALOG:
			WNDCLASS	wc;
			wc.style			= CS_HREDRAW | CS_VREDRAW;
			wc.lpfnWndProc		= (WNDPROC)GraphicViewProc;
			wc.cbClsExtra		= 0;
			wc.cbWndExtra		= 0;
			wc.hInstance		= g_hInst;
			wc.hIcon			= NULL;
			wc.hCursor			= 0;
			wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
			wc.lpszMenuName		= 0;
			wc.lpszClassName	= TEXT("GRAPHIC_VIEW");
			RegisterClass(&wc);

			GetClientRect(hWnd, &rc); 
			x = rc.left+20; 
			y = rc.top+10; 
			nWidth=rc.right-rc.left-40; 
			nHeight=rc.bottom-rc.top-60; 
			CreateWindow(TEXT("GRAPHIC_VIEW"), TEXT("GRAPHIC_VIEW"), 
					WS_CHILD|WS_VISIBLE,
					x,y,nWidth,nHeight, hWnd, (HMENU)NULL, g_hInst, (LPVOID)&resourceId);
			break; 

		case WM_COMMAND:
			switch(wParam) 
			{ 
				case IDM_GRAPHIC_PRINT:
					GraphicPrint(hWnd);
					break;

				case IDCANCEL:
					EndDialog(hWnd, TRUE); 
					break;
			} 
		    break; 

		case WM_CLOSE:
			EndDialog(hWnd, TRUE); 
			break;

		case WM_DESTROY:
			EndDialog(hWnd, TRUE);
			break;
	}
	return FALSE;
}

//-------------------------------------------------------------
//		GraphicPrint
//-------------------------------------------------------------
void GraphicPrint(HWND hWnd)
{
	DWORD dwResult;

	dwResult=GraphicPrintExec(hWnd);
	if(dwResult==RETRY_CANCEL)
	{
		return;
	}
	if(dwResult!= PRN_NORMAL)
	{
		MessageBox(hWnd,  errorMsg[dwResult],c_szCONFERM,
			MB_OK | MB_ICONERROR | MB_TOPMOST);
		return;
	}

	MessageBox(hWnd, c_szPRINTFINISH,c_szCONFERM,MB_OK);
	SendMessage(hWnd, WM_CLOSE, 0, 0L);
	return;
}

//-------------------------------------------------------------
// 	 GraphicPrintExec
//-------------------------------------------------------------
DWORD GraphicPrintExec(HWND hWnd)
{
	DWORD dwResult=PRN_NORMAL;
	DWORD dwWidth;
	DWORD dwContinuation;

	dwResult=PRNOpen();
	if(dwResult!=PRN_NORMAL)
	{
		return dwResult;
	}

	dwResult=PRNGetPaperWidth(&dwWidth);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();	 
		return dwResult;
	}
	
	if(dwWidth==PAPER_WIDTH58)
	{	
		PRNClose();	 
		return AP_ERROR_WIDTH;
	}

	dwResult=GetPrintContinuation(&dwContinuation);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();
		return dwResult;
	}

	IMAGE_DATA image;
	GetImageData(&image,IDB_GRAPHIC) ;

	dwResult=PRNImageOut(image.dwWidth/8, image.dwHeight, 
							image.dwBitsPixel,image.pImageByte);
	if((dwResult!=PRN_NORMAL) && (dwContinuation!=TRUE))
	{
		DeleteImageData(&image);
		dwResult=SendCancel();
		PRNClose();
		return dwResult;
	}	

	dwResult= WaitForPrintOut(hWnd,dwContinuation);
	PRNClose();
	DeleteImageData(&image);
	return 	dwResult;
}
//-------------------------- END OF FILE -------------------------------------------------------------

