/******************************************************************************
*  prnText.cpp                                                                *
*                                                                             *
*  Project : Printer Demo Application for DT-9700/IT-3000                     *
*  Date    : 2004-03-05                                                       *
*  Version : 1.0.0                                                            *
*                                                                             *
*  Copyright (C) 2004, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
*                                                                             *
******************************************************************************/
#include    "PrinterLibSampleVC.h"

extern PRINT_FORM SAMPLE_TEXT[];
//-------------------------------------------------------------
//	TextPrint
//-------------------------------------------------------------
void TextPrint(HWND hWnd)
{
	DWORD dwResult;

	dwResult= TextPrintExec(hWnd);
	if(dwResult==RETRY_CANCEL)
	{
		return;
	}
	if(dwResult!= PRN_NORMAL)
	{
		MessageBox(hWnd,  errorMsg[dwResult],c_szCONFERM,
			MB_OK | MB_ICONERROR | MB_TOPMOST);
		return;
	}
	MessageBox(hWnd, c_szPRINTFINISH,c_szCONFERM,MB_OK);
	return;
}

//-------------------------------------------------------------
// TextPrintExec
//-------------------------------------------------------------
DWORD TextPrintExec(HWND hWnd)
{
	DWORD  dwResult=PRN_NORMAL; 
	DWORD  dwWidth;
	DWORD  dwContinuation;

	dwResult=PRNOpen();
	if(dwResult!=PRN_NORMAL)
	{
		return dwResult;
	}

	dwResult=PRNGetPaperWidth(&dwWidth);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();	 
		return dwResult;
	}
	
	if(dwWidth==PAPER_WIDTH58)
	{	
		PRNClose();	 
		return AP_ERROR_WIDTH;
	}

	dwResult=GetPrintContinuation(&dwContinuation);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();
		return dwResult;
	}

	for(int i=0;SAMPLE_TEXT[i].printString!=NULL; i++)
	{
		dwResult = PRNTextOut(SAMPLE_TEXT[i].stringLength,
							SAMPLE_TEXT[i].printString);
		if(dwResult!=PRN_NORMAL)
		{
			if( dwContinuation ==TRUE) 
			{
				dwResult= WaitForPrintOut(hWnd,dwContinuation);
				if(dwResult==PRN_NORMAL)
				{
					continue;
				}
				else
				{
					PRNClose();
					return dwResult;
				}
			}
			else
			{
				dwResult=SendCancel();
				PRNClose();
				return dwResult;
			}
		}
	}
	dwResult= WaitForPrintOut(hWnd,dwContinuation);
	PRNClose();
	return dwResult;
}
//--------------------------End Of File--------------------------------
