/******************************************************************************
*  prnTextFrom.cpp                                                            *
*                                                                             *
*  Project : Printer Demo Application for IT-3000                             *
*  Date    : 2004-03-05                                                       *
*  Version : 1.0.0                                                            *
*                                                                             *
*  Copyright (C) 2004, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
*                                                                             *
******************************************************************************/
#include    "PrinterLibSampleVC.h"

//-------------------------------------------------------------
// ESC Command
//-------------------------------------------------------------
TCHAR ESC_Z[]   = {ESC,'Z',0x01};
TCHAR ESC_J[]   = {ESC,'J',0x00};
TCHAR ESC_F16[] = {ESC,'F',0x02};
TCHAR ESC_F24[] = {ESC,'F',0x03};
TCHAR ESC_A00[] = {ESC,'A',0x00};
TCHAR ESC_A04[] = {ESC,'A',0x04};
TCHAR ESC_S11[] = {ESC,'S',0x00,0x00};
TCHAR ESC_S21[] = {ESC,'S',0x02,0x00};
TCHAR CRLF[]    = {0x0D,0x0A};

//--------------------------------------------------------------
// Print Text Sample
//--------------------------------------------------------------
PRINT_FORM SAMPLE_TEXT[] = {
	sizeof(ESC_Z)/sizeof(TCHAR),ESC_Z,
	sizeof(ESC_J)/sizeof(TCHAR),ESC_J,
	sizeof(ESC_F24)/sizeof(TCHAR),ESC_F24,
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	sizeof(ESC_S21)/sizeof(TCHAR),ESC_S21,
	0,TEXT("IT-3000 Demo Application\n"),
	0,TEXT("IT-3000 Specifications\n"),
	sizeof(ESC_S11)/sizeof(TCHAR),ESC_S11,
	0,TEXT("===============================================\n"),
	0,TEXT("OS        : Microsoft WindowsCE.NET 4.1\n"),
	0,TEXT("CPU       : Intel(R)PXA255 400MHz(Max)\n"),
	0,TEXT("RAM       : 64MB\n"),
	0,TEXT("Flash ROM : 64MB(System)/32MB(User)\n"),
	0,TEXT("Display   : 3.5inch 2-way TFT color LDC\n"),
	0,TEXT("Keybord   : NumericKeys.CLR/ENT/BS/FNC/FeedKeys\n"),
	0,TEXT("          : PowerKey/ProgramableKey\n"),
	0,TEXT("TouchPanel: Resolution:240x320\n"),
	0,TEXT("Interface : IrDA/Bluetooth/Serial(8pin,14pin)\n"),
	0,TEXT("          : PCMCIA TYPE II/SD Memory Card\n"),
	0,TEXT("Dimensions: Approx. 80x199.5x28mm\n"),
	0,TEXT("Weight    : Approx. 530g\n"),
	0,TEXT("-----------------------------------------------\n"),
	sizeof(ESC_F16)/sizeof(TCHAR),ESC_F16,
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	sizeof(ESC_S21)/sizeof(TCHAR),ESC_S21,
	0,TEXT("[Printer Specifications]\n"),
	sizeof(ESC_F24)/sizeof(TCHAR),ESC_F24,
	sizeof(ESC_S11)/sizeof(TCHAR),ESC_S11,
	0,TEXT("  Printing method: Thermal sensitive line dot\n"),
	0,TEXT("                 : method\n"),
	0,TEXT("  Paper width    : 80mm or 58mm\n"),
	0,TEXT("  Dot structure  : 576 or 384(dot/line)\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("  Dot pitch      : 0.125mm(8dots/mm)-Dot density\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("  (Horizontal)   :\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("  Dot pitch      : 0.125mm(8dots/mm)-Line feed\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("  (Vertical)     : pitch\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("  Effective      : 72mm or 48mm\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("   printing area :\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("  Character types: Alphanumeric, katakana \n"),
	0,TEXT("                 : International and special \n"),
	0,TEXT("                 : characters\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("                 : JIS Kanji level-1, level-2\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("  Character      : 6x7   dots: ANK\n"),
	0,TEXT("   dimensions    : 6x12  dots: ANK\n"),
	0,TEXT("       (HxW)     : 8x16  dots: ANK\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("                 : 12x24 dots: ANK\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("                 : 12x12 dots: Kanji\n"),
	0,TEXT("                 : 16x16 dots: Kanji\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("                 : 24x24 dots: Kanji\n"),
	sizeof(ESC_A00)/sizeof(TCHAR),ESC_A00,
	0,TEXT("                 : 16x30 dots: OCR-B\n"),
	0,TEXT("                 : 24x45 dots: OCR-B\n"),
	sizeof(ESC_A04)/sizeof(TCHAR),ESC_A04,
	0,TEXT("===============================================\n"),
	0,TEXT("CASIO COMPUTER CO.,Ltd.\n"),
	0,TEXT("http://world.casio.com/\n"),
	0,TEXT("-----------------------------------------------\n"),
	sizeof(CRLF)/sizeof(TCHAR),CRLF,
	sizeof(CRLF)/sizeof(TCHAR),CRLF,
	0,NULL
};

//-------------------------- End Of File ----------------------------------------------
