/******************************************************************************
*  prnUserDef.cpp                                                             *
*                                                                             *
*  Project : Printer Demo Application for DT-9700/IT-3000                     *
*  Date    : 2004-03-05                                                       *
*  Version : 1.0.0                                                            *
*                                                                             *
*  Copyright (C) 2004, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
*                                                                             *
******************************************************************************/
#include    "PrinterLibSampleVC.h"

static int fontSize;
//-----------------------------------------------------------------------------
//	User Definition Character(BITMP Resource)
//-----------------------------------------------------------------------------
static const int bitmapID[4]={NULL,IDB_GAIJI_12, IDB_GAIJI_16,IDB_GAIJI_24};

//-------------------------------------------------------------
//		ExtCharWndProc
//-------------------------------------------------------------
LRESULT CALLBACK WINAPI	ExtCharWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	HWND hEdit, hUpdown;
	UINT check;

	switch (message) 
	{
		case WM_INITDIALOG:
			{
			hEdit   = GetDlgItem(hWnd, IDC_EXTCHAR_CODE);
			hUpdown = GetDlgItem(hWnd, IDC_EXTCODE_SPIN);

			SendMessage(hUpdown, UDM_SETBUDDY, (WPARAM)hEdit, 0);
			SendMessage(hUpdown, UDM_SETBASE , (WPARAM)16, 0);
			SendMessage(hUpdown, UDM_SETRANGE32, (WPARAM)0xE100  , (LPARAM)0xE17F);
			SendMessage(hUpdown, UDM_SETPOS, 0, (LPARAM)MAKELONG((short)0, 0));

			Button_SetCheck(GetDlgItem(hWnd, IDC_RADIO_FONT16), BST_CHECKED);
			fontSize=FONT_SIZE16;
			}
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) 
			{
				case IDC_RADIO_FONT12:
					check=IsDlgButtonChecked(hWnd,IDC_RADIO_FONT12);
					if(check == BST_CHECKED)
					{
						fontSize=FONT_SIZE12;
					}
					break;

				case IDC_RADIO_FONT16:
					check=IsDlgButtonChecked(hWnd,IDC_RADIO_FONT16);
					if(check == BST_CHECKED)
					{
						fontSize=FONT_SIZE16;
					}
					break;

				case IDC_RADIO_FONT24:
					check=IsDlgButtonChecked(hWnd,IDC_RADIO_FONT24);
					if(check == BST_CHECKED)
					{
						fontSize=FONT_SIZE24;
					}
					break;

				case IDM_EXTCHAR_REGIST:
						RegistUserDef(hWnd);
						break;

				case IDM_EXTCHAR_PRINT:
						PrintUserDef(hWnd);
						break;

				case   IDCANCEL:
					EndDialog(hWnd, TRUE); 
					break;
			}
			break;
		case WM_CLOSE:
			EndDialog(hWnd, TRUE); 
			break;

		case WM_DESTROY:
			EndDialog(hWnd, TRUE); 
			break;
		
		default:
			return FALSE;
	}

	return TRUE;
}

//-------------------------------------------------------------
//		RegistUserDef
//-------------------------------------------------------------
void RegistUserDef(HWND hWnd)
{
	DWORD dwResult;

	dwResult= RegistUserDefExec(hWnd);
	if(dwResult !=PRN_NORMAL)
	{
		MessageBox(hWnd, errorMsg[dwResult],c_szCONFERM,
			MB_OK | MB_ICONERROR | MB_TOPMOST);
		return;
	}
	MessageBox(hWnd, c_szREGISTFINISH,c_szCONFERM,MB_OK);
	return;
}


//-------------------------------------------------------------
//		RegistUserDefExec
//-------------------------------------------------------------
DWORD RegistUserDefExec(HWND hWnd)
{

	DWORD  dwResult, strLen;
	TCHAR ESC_F[] = {ESC,'F',1,0};
	TCHAR ESC_m[] = {ESC,'m',1,0};

	dwResult=PRNOpen();
	if(dwResult!=PRN_NORMAL)
	{
		return dwResult;
	}

	dwResult = PRNGetStatus();
	if(dwResult!=PRN_NORMAL)
	{
		SendCancel();
	}

	ESC_F[2]=fontSize;
	dwResult = PRNTextOut(wcslen(ESC_F),ESC_F);

	dwResult=CheckRegistError(dwResult);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();
		return dwResult;
	}	

	DWORD dwCode = (DWORD)SendDlgItemMessage( hWnd, IDC_EXTCODE_SPIN, UDM_GETPOS, 0, 0);
	dwCode = dwCode & 0x0000FFFF;

	IMAGE_DATA image;
	GetFontData(&image, bitmapID[fontSize]); 

	TCHAR *pBuff = new TCHAR[image.dwImageSize+wcslen(ESC_m)];
	memcpy(&pBuff[wcslen(ESC_m)], image.pImageWbyte, image.dwImageSize*2);
	
	pBuff[0]=ESC;
	pBuff[1]='m';
	pBuff[2]=(unsigned short)dwCode;
	strLen=wcslen(ESC_m)+image.dwImageSize;

	dwResult = PRNGetStatus();
	if(dwResult!=PRN_NORMAL)
	{
		SendCancel();
	}

	dwResult = PRNTextOut(strLen,pBuff);
	dwResult=CheckRegistError(dwResult);

	PRNClose();
	delete[] pBuff;
	DeleteImageData(&image);
	return PRN_NORMAL;
}

//-------------------------------------------------------------
//		PrintUserDef 
//-------------------------------------------------------------
void PrintUserDef(HWND hWnd)
{
	DWORD dwResult;

	dwResult= PrintUserDefExec(hWnd);
	if(dwResult==RETRY_CANCEL)
	{
		return;
	}
	if(dwResult !=PRN_NORMAL)
	{
		MessageBox(hWnd, errorMsg[dwResult],c_szCONFERM,
			MB_OK | MB_ICONERROR | MB_TOPMOST);
		return;
	}
	MessageBox(hWnd, c_szPRINTFINISH,c_szCONFERM,MB_OK);
	return;
}

//-------------------------------------------------------------
//		PrintUserDefExec
//-------------------------------------------------------------
DWORD PrintUserDefExec(HWND hWnd)
{
	DWORD dwResult=PRN_NORMAL;
	DWORD dwWidth;
	DWORD dwContinuation;

	TCHAR ESC_F[] = {ESC,'F',1,0};

	dwResult=PRNOpen();
	if(dwResult!=PRN_NORMAL)
	{
		return dwResult;
	}

	dwResult=PRNGetPaperWidth(&dwWidth);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();	 
		return dwResult;
	}
	if(dwWidth==PAPER_WIDTH58)
	{	
		PRNClose();	 
		return AP_ERROR_WIDTH;
	}
	
	dwResult = PRNGetStatus();
	if(dwResult!=PRN_NORMAL)
	{
		SendCancel();
	}

	ESC_F[2]=fontSize;
	dwResult = PRNTextOut(wcslen(ESC_F),ESC_F);

	dwResult=CheckRegistError(dwResult);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();
		return dwResult;
	}

	dwResult=GetPrintContinuation(&dwContinuation);
	if(dwResult!=PRN_NORMAL)
	{
		PRNClose();
		return dwResult;
	}

	DWORD dwCode = (DWORD)SendDlgItemMessage( hWnd, IDC_EXTCODE_SPIN, UDM_GETPOS, 0, 0);
	dwCode = dwCode & 0x0000FFFF;

	TCHAR buff[4];
	buff[0]=(unsigned short)dwCode;
	buff[1]=0x0D;
	buff[2]=0x00;
	buff[3]=0x00;

	dwResult = PRNTextOut(wcslen(buff),buff);
	if((dwResult!=PRN_NORMAL) && (dwContinuation!=TRUE))
	{
		dwResult=SendCancel();
		PRNClose();
		return dwResult;
	}

	dwResult= WaitForPrintOut(hWnd,dwContinuation);
	PRNClose();
	return dwResult;
}
//-------------------------- END OF FILE -------------------------------------------------------------