/******************************************************************************
*  prnDemo.h                                                                  *
*                                                                             *
*  Project : Printer Demo Application for IT-9000                     *
*  Date    : 2012-05-28                                                       *
*  Version : 1.0.0                                                            *
*                                                                             *
*  Copyright (C) 2012, CASIO COMPUTER CO.,Ltd. All rights reserved.           *
*                                                                             *
******************************************************************************/
#if !defined(AFX_PRNDEMO_H__050EECFC_CA59_4840_9E5D_0DA75B934C9F__INCLUDED_)
#define AFX_PRNDEMO_H__050EECFC_CA59_4840_9E5D_0DA75B934C9F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include	<windows.h>
#include	<windowsx.h>
#include	<Commctrl.h>
#include	<commdlg.h>
#include	"resourceppc.h"
#include	"PrinterLib.h"


//------------------------------------------------------------------------------------
//	DEFINES
//------------------------------------------------------------------------------------
enum 
{
	FONT_SIZE12=1,
	FONT_SIZE16,
	FONT_SIZE24
};

#define TRAY_ID				1
#define WM_TRAY				WM_APP + 100
#define ESC					0x1B
#define RETRY_CANCEL		0x80000000
#define PAPER_WIDTH58		1
#define AP_ERROR_WIDTH		PRN_FEEDKEY_ERROR+1

extern HINSTANCE	g_hInst;
extern TCHAR const c_szAPNAME[];
extern TCHAR const c_szFORMS[];
extern TCHAR const c_szGRAPHIC[];
extern TCHAR const c_szSCREEN[];
extern TCHAR const c_szSTAMP[];
extern TCHAR const c_szEXTCHAR[];
extern TCHAR const c_szCONFERM[];
extern TCHAR const c_szPRINTFINISH[];
extern TCHAR const c_szREGISTFINISH[];
extern TCHAR const c_szMAXWINDOW[];
extern TCHAR const c_szEXIT[];
extern LPCTSTR const errorMsg[];

//------------------------------------------------------------------------------------
//	PROTOTYPE DECLARATION
//------------------------------------------------------------------------------------
LRESULT CALLBACK WINAPI	WndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK WINAPI	GraphicWndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK WINAPI	StampWndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK WINAPI	ExtCharWndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK WINAPI	GraphicViewProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK WINAPI	StampViewProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
//LRESULT CALLBACK About(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

//------------------------------------------------------------------------------------
//	PRIVATE DATA
//------------------------------------------------------------------------------------
struct IMAGE_DATA
{
	DWORD dwWidth;
	DWORD dwHeight;
	DWORD dwImageSize;
	DWORD dwBitsPixel;
	DWORD dwPlanes;
	BYTE * pImageByte;
	TCHAR * pImageWbyte;
};

struct PRINT_FORM
{
	DWORD stringLength;
	LPTSTR printString;
}; 

//----------------------------------------------------
// Text Print Function
//----------------------------------------------------
void  TextPrint(HWND hwnd);
DWORD TextPrintExec(HWND hWnd);

//----------------------------------------------------
// GraphicImage Print Function
//----------------------------------------------------
void  GraphicPrint(HWND hWnd);
DWORD GraphicPrintExec(HWND hWnd);

//----------------------------------------------------
// Screen Print Function
//----------------------------------------------------
void  ScreenPrint(HWND hWnd);
DWORD ScreenPrintExec(HWND hWnd);

//----------------------------------------------------
// Stamp Registration Function
//----------------------------------------------------
void  RegisterStamp(HWND hWnd);
DWORD RegisterStampExec();

//----------------------------------------------------
// Stamp Print FUnction
//----------------------------------------------------
void  PrintStamp(HWND hWnd);
DWORD PrintStampExec(HWND hWnd);

//----------------------------------------------------
// User Definition Character Registration Function
//----------------------------------------------------
void  RegistUserDef(HWND hWnd);
DWORD RegistUserDefExec(HWND hWnd);

//----------------------------------------------------
// User Definition Character Print Function
//----------------------------------------------------
void  PrintUserDef(HWND hWnd);
DWORD PrintUserDefExec(HWND hWnd);

//----------------------------------------------------
// Local Functions
//----------------------------------------------------
void  GetImageData(IMAGE_DATA*,WORD) ;
void  GetFontData(IMAGE_DATA* pImage,WORD id); 
int   getPadingByte(int width);
int   getRealByte(int width) ;
void  DeletePading(void *pBits,IMAGE_DATA* image);
void  ReversBitmap(void *pBits,IMAGE_DATA* image);
void  DeleteImageData(IMAGE_DATA* image);
DWORD SendCancel();
DWORD GetPrintContinuation(DWORD* pContinuation);
DWORD CheckRegistError(DWORD dwResult);
DWORD WaitForPrintOut(HWND hWnd, DWORD dwContinuation);

#endif // !defined(AFX_PRNDEMO_H__050EECFC_CA59_4840_9E5D_0DA75B934C9F__INCLUDED_)
//-------------------------------End Of File------------------------------------------
