'***************************************************************************
'* <Description>
'* SAMMain.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* SAM Card accessing program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target>
'* IT-9000 WM
'* -------------------------------------------------------------------------
'* Copyright(C)2012 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2012.05.24      CASIO       000000      Original      
'* 
'***************************************************************************/
Imports Calib.NFCLibNet.Api
Imports Calib.NFCLibNet.Def
Imports Calib.SystemLibNet.Api
Imports Calib.SystemLibNet.Def
Imports Calib.SAMLibNet.Api
Imports Calib.SAMLibNet.Def

Public Class SAMMain
    Dim i As Integer
    Dim iRet As Integer
    Dim strCommand As String
    Dim dwNumberOfSlot As Integer
    Dim iActBaudRate As Integer
    Dim dwActualNfc As Integer

    'For SAMExchangeData
    'The following send data is dummy.
    Dim dwSlotNumber As Integer = 0
    Dim pbySendSam(506) As Byte
    Dim dwSendSam As Integer = 10
    Dim pbyReceiveSam(506) As Byte

    'For NFCExchangeData
    'The following send data is dummy.
    Dim pbySendNfc(261) As Byte
    Dim dwSendNfc As Integer = 10
    Dim pbyReceiveNfc(261) As Byte

    'For SAMGetCardResponse
    Dim pdwActualSam(3 + 1) As Integer '3:MAX_NUM_SLOT
    Dim pbyTargetSam1(506) As Byte '3:MAX_NUM_SLOT
    Dim pbyTargetSam2(506) As Byte '3:MAX_NUM_SLOT
    Dim pbyTargetSam3(506) As Byte '3:MAX_NUM_SLOT

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button1.Enabled = False

        If comboBox1.SelectedIndex = 0 Then
            SAM_Access()
        Else
            NFC_Scan()
        End If

        Button1.Enabled = True
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub

    Private Sub SAM_Access()

        Dim dwActualSam As Integer

        'Modify your SAMExchangeData code.
        textBox1.Text = "SAMExchangeData...start."
        dwActualSam = 0
        iRet = SAMExchangeData(dwSlotNumber, pbySendSam, dwSendSam, pbyReceiveSam, dwActualSam, 0)
        If iRet <> SAM_OK Then

            strCommand = "SAMExchangeData"
            DispSamErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMExchangeData...OK."

        SysSetBuzzerVolume(B_SCANEND, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_SCANEND, B_USERDEF, B_USERDEF)
    End Sub

    Private Sub NFC_Scan()

        Dim dwActualSam As Integer

        'NFC POLLING
        textBox1.Text = "NFCPollingCard...start."
#If HFTAG_UNSUPPORTED Then
        iRet = NFCPollingCard(NFC_BAUD_TYPEA Or NFC_BAUD_TYPEB Or NFC_BAUD_FELICA1 Or NFC_BAUD_FELICA2, 10000, IntPtr.Zero, iActBaudRate, 0)
#Else
        iRet = NFCPollingCard(NFC_BAUD_TYPEA Or NFC_BAUD_TYPEB Or NFC_BAUD_FELICA1 Or NFC_BAUD_FELICA2 Or NFC_BAUD_HFTAGE, 10000, IntPtr.Zero, iActBaudRate, 0)
#End If
        If iRet <> NFC_OK Then
            strCommand = "NFCPollingCard"
            DispNfcErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "NFCPollingCard...OK."

        'Modify your SAMExchangeData code.
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMExchangeData...start."
        dwActualSam = 0
        iRet = SAMExchangeData(dwSlotNumber, pbySendSam, dwSendSam, pbyReceiveSam, dwActualSam, 0)
        If iRet <> SAM_OK Then

            strCommand = "SAMExchangeData"
            DispSamErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMExchangeData...OK."

        'Modify your NFCExchangeData code.
        'In case of sample, in order to transmit dummy data, function returns error.
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "NFCExchangeData...start."
        dwActualNfc = 0
        iRet = NFCExchangeData(pbySendNfc, dwSendNfc, pbyReceiveNfc, dwActualNfc, 0)
        If iRet <> NFC_OK Then
            strCommand = "NFCExchangeData"
            DispNfcErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "NFCExchangeData...OK."


        'Append your SAMExchangeData code.


        'Append your NFCExchangeData code.


        'NFC RADIO OFF
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "NFCRadioOff...start."
        iRet = NFCRadioOff()
        If iRet <> NFC_OK Then
            strCommand = "NFCRadioOff"
            DispNfcErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "NFCRadioOff...OK."

        button1.Enabled = True
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "NFC scanning...OK."
        SysSetBuzzerVolume(B_SCANEND, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_SCANEND, B_USERDEF, B_USERDEF)
    End Sub

    Function DispNfcErrorMessage(ByVal iRet As Integer, ByVal strCommand As String) As Boolean
        Select Case iRet
            Case NFC_PON
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : NFC already opend."
            Case NFC_NOT_DEVICE
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : NFC driver error."
            Case NFC_ERROR_INVALID_ACCESS
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Device exclusive error."
            Case NFC_ERROR_MODULE
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : NFC module not responce error."
            Case NFC_POF
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : NFC not open error."
            Case NFC_PRM
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : NFC parameter error."
            Case NFC_ERROR_TIMEOUT
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Timeout error."
            Case NFC_ERROR_CALLBACK
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Call back function error."
            Case NFC_ERROR_STOP
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Stop error by stop function."
            Case NFC_NOT_ACTIVATION
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Card don't start error."
            Case Else
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Other error."
        End Select

        SysSetBuzzerVolume(B_WARNING, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_WARNING, B_USERDEF, B_USERDEF)

        'NFCClose()
        Button1.Enabled = True
    End Function

    Function DispSamErrorMessage(ByVal iRet As Integer, ByVal strCommand As String) As Boolean

        Select Case iRet
            Case SAM_PON
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : SAM already opened."
            Case SAM_NOT_DEVICE
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : SAM driver error."
            Case SAM_ERROR_INVALID_ACCESS
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Device exclusive error."
            Case SAM_ERROR_MODULE
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : SAM module not responce error."
            Case SAM_POF
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : SAM not open error."
            Case SAM_PRM
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : SAM parameter error."
            Case SAM_ERROR_TIMEOUT
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Timeout error."
            Case SAM_NOT_ACTIVATION
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Card don't start error."
            Case SAM_ERROR_SUSPEND
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Suspend error."
            Case SAM_ERROR_RESPONSE
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Card response error."
            Case SAM_ERROR_NOCARD
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Card does not exist."
            Case Else
                textBox1.Text = textBox1.Text + ControlChars.NewLine + strCommand + " : Other error."
        End Select

        SysSetBuzzerVolume(B_WARNING, BUZZERVOLUME_MAX)
        SysPlayBuzzer(B_WARNING, B_USERDEF, B_USERDEF)

        'SAMClose()
        Button1.Enabled = True
    End Function

    Private Sub SAMMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Init
        For i = 0 To i < 10
            pbySendSam(i) = i + 1
            pbySendNfc(i) = i + 1
        Next

        comboBox1.SelectedIndex = 0

        'NFC OPEN
        textBox1.Text = "NFCOpen...start."
        iRet = NFCOpen(IntPtr.Zero)
        If iRet <> NFC_OK Then
            strCommand = "NFCOpen"
            DispNfcErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMOpen...OK."

        'SAM OPEN
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMOpen...start."
        iRet = SAMOpen()
        If iRet <> NFC_OK Then
            strCommand = "SAMOpen"
            DispSamErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMOpen...OK."

        'SAM GET NUMBER OF SLOT
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMGetNumberOfSlot...start."
        iRet = SAMGetNumberOfSlot(dwNumberOfSlot)
        If iRet <> NFC_OK Then
            strCommand = "SAMGetNumberOfSlot"
            DispSamErrorMessage(iRet, strCommand)
            Exit Sub
        End If
        textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMGetNumberOfSlot...OK."

        For i = 1 To dwNumberOfSlot
            comboBox2.Items.Add(i)

            ' SAM POWERUP
            textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMPowerUpCard(" + i.ToString() + ")...start."
            iRet = SAMPowerUpCard(i, SAM_POWER_ISO)
            If iRet = SAM_OK Then
                textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMPowerUpCard(" + i.ToString() + ")...OK."

                ' SAM GET CARD RESPONSE
                textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMGetCardResponse(" + i.ToString() + ")...start."
                pdwActualSam(i) = 0
                If i = 1 Then
                    iRet = SAMGetCardResponse(i, pbyTargetSam1, pdwActualSam(i), 0)
                ElseIf i = 2 Then
                    iRet = SAMGetCardResponse(i, pbyTargetSam2, pdwActualSam(i), 0)
                ElseIf i = 3 Then
                    iRet = SAMGetCardResponse(i, pbyTargetSam3, pdwActualSam(i), 0)
                End If
                If iRet = SAM_OK Then
                    textBox1.Text = textBox1.Text + ControlChars.NewLine + "SAMGetCardResponse(" + i.ToString() + ")...OK."
                Else
                    strCommand = "SAMGetCardResponse(" + i.ToString() + ")"
                    DispSamErrorMessage(iRet, strCommand)
                End If
            Else
                strCommand = "SAMPowerUpCard(" + i.ToString() + ")"
                DispSamErrorMessage(iRet, strCommand)
            End If
        Next

        comboBox2.SelectedIndex = 0
        dwSlotNumber = 1

        ' DispHex
        label4.Text = ""
        For i = 0 To pdwActualSam(dwSlotNumber) - 1
            If dwSlotNumber = 1 Then
                label4.Text = label4.Text + pbyTargetSam1(i).ToString("X2") + " "
            ElseIf dwSlotNumber = 2 Then
                label4.Text = label4.Text + pbyTargetSam2(i).ToString("X2") + " "
            ElseIf dwSlotNumber = 3 Then
                label4.Text = label4.Text + pbyTargetSam3(i).ToString("X2") + " "
            End If
        Next

    End Sub

    Private Sub SAMMain_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        NFCClose()
        SAMClose()
    End Sub

    Private Sub comboBox2_change(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox2.SelectedIndexChanged

        ' DispHex
        label4.Text = ""
        dwSlotNumber = comboBox2.SelectedIndex + 1

        For i = 0 To pdwActualSam(dwSlotNumber) - 1
            If dwSlotNumber = 1 Then
                label4.Text = label4.Text + pbyTargetSam1(i).ToString("X2") + " "
            ElseIf dwSlotNumber = 2 Then
                label4.Text = label4.Text + pbyTargetSam2(i).ToString("X2") + " "
            ElseIf dwSlotNumber = 3 Then
                label4.Text = label4.Text + pbyTargetSam3(i).ToString("X2") + " "
            End If
        Next
    End Sub

End Class
