/***************************************************************************
 * <Description>
 * Form_LED.cs (Casio Computer Co., Ltd.)
 * -------------------------------------------------------------------------
 * <Function outline>
 * System Library Demo program
 * -------------------------------------------------------------------------
 * <Language>
 * C#.NET
 * -------------------------------------------------------------------------
 * <Develop Environment>
 * VS 2005
 * -------------------------------------------------------------------------
 * <Target>
 * DT-5300 WM / IT-800 WM model
 * -------------------------------------------------------------------------
 * Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
 * -------------------------------------------------------------------------
 * <History>
 * Version  Date            Company     Keyword     Comment
 * 1.0.0    2010.02.16      CASIO       000000      Original      
 * 
 ***************************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Calib;

namespace SystemLibSampleCSWM
{
    public partial class Form_LED : Form
    {
        public Form_LED()
        {
            InitializeComponent();
        }

        private void button_Green_Click(object sender, EventArgs e)
        {
            SetLED(Calib.SystemLibNet.Def.LED_GREEN);
        }

        private void button_Red_Click(object sender, EventArgs e)
        {
            SetLED(Calib.SystemLibNet.Def.LED_RED);
        }

        private void button_Orange_Click(object sender, EventArgs e)
        {
            SetLED(Calib.SystemLibNet.Def.LED_ORANGE);
        }

        private void button_Blue_Click(object sender, EventArgs e)
        {
            SetLED(0x0000000B);
        }

        private void button_Cyan_Click(object sender, EventArgs e)
        {
            SetLED(0x0000000C);	
        }

        private void button_Magenta_Click(object sender, EventArgs e)
        {
            SetLED(0x0000000D);
        }

        private void button_Off_Click(object sender, EventArgs e)
        {
            SetLED(Calib.SystemLibNet.Def.LED_OFF);
        }

        private void button_Get_Click(object sender, EventArgs e)
        {
            int dwRet;

            // get LED ON/OFF condition
            dwRet = Calib.SystemLibNet.Api.SysGetLED();
            switch (dwRet)
            {
                case Calib.SystemLibNet.Def.LED_GREEN:
                    MessageBox.Show("Green", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                case Calib.SystemLibNet.Def.LED_RED:
                    MessageBox.Show("Red", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                case Calib.SystemLibNet.Def.LED_ORANGE:
                    MessageBox.Show("Orange", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                case 0x0000000B:
                    MessageBox.Show("Blue", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                case 0x0000000C:
                    MessageBox.Show("Cyan", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                case 0x0000000D:
                    MessageBox.Show("Magenta", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                case Calib.SystemLibNet.Def.LED_OFF:
                    MessageBox.Show("LED Off", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
                default:
                    MessageBox.Show("Other condition!", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                    break;
            }
        }

        private void SetLED(int dwMode)
        {
            int dwNum, dwOnTime, dwOffTime;

            // LED ON count get
            dwNum = Convert.ToInt32(textBox_Num.Text);

            // LED ON time get
            dwOnTime = Convert.ToInt32(textBox_OnTime.Text);

            // LED OFF time get
            dwOffTime = Convert.ToInt32(textBox_OffTime.Text);

            // LED ON/OFF
            Calib.SystemLibNet.Api.SysSetLED(dwMode, dwNum, dwOnTime, dwOffTime);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();

        }


    }
}