'***************************************************************************
'* <Description>
'* Form_LED.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* System Library Demo program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target>
'* DT-5300 WM / IT-800 WM / IT-300 model
'* -------------------------------------------------------------------------
'* Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2010.02.16      CASIO       000000      Original      
'* 
'***************************************************************************/
Imports Calib.SystemLibNet.Def
Imports Calib.SystemLibNet.Api

Public Class Form_LED


    Private Sub button_Green_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Green.Click
        SetLED(LED_GREEN)
    End Sub

    Private Sub button_Red_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Red.Click
        SetLED(LED_RED)
    End Sub

    Private Sub button_Orange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Orange.Click
        SetLED(LED_ORANGE)
    End Sub

    Private Sub button_Blue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Blue.Click
        SetLED(&HB)
    End Sub

    Private Sub button_Cyan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Cyan.Click
        SetLED(&HC)
    End Sub

    Private Sub button_Magenta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Magenta.Click
        SetLED(&HD)
    End Sub

    Private Sub button_Off_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Off.Click
        SetLED(LED_OFF)
    End Sub

    Private Sub SetLED(ByVal dwMode As Int32)
        Dim dwNum As Int32, dwOnTime As Int32, dwOffTime As Int32

        ' LED ON count get
        dwNum = Convert.ToInt32(textBox_Num.Text)

        ' LED ON time get
        dwOnTime = Convert.ToInt32(textBox_OnTime.Text)

        ' LED OFF time get
        dwOffTime = Convert.ToInt32(textBox_OffTime.Text)

        ' LED ON/OFF
        SysSetLED(dwMode, dwNum, dwOnTime, dwOffTime)

    End Sub

    Private Sub button_Get_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Get.Click
        Dim dwRet As Int32

        ' get LED ON/OFF condition
        dwRet = SysGetLED()
        Select Case dwRet
            Case LED_GREEN
                MessageBox.Show("Green", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case LED_RED
                MessageBox.Show("Red", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case LED_ORANGE
                MessageBox.Show("Orange", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case &HB
                MessageBox.Show("Blue", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case &HC
                MessageBox.Show("Cyan", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case &HD
                MessageBox.Show("Magenta", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case LED_OFF
                MessageBox.Show("LED_Off", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Case Else
                MessageBox.Show("Other condition!", "SysGetLED", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
        End Select
    End Sub

    Private Sub Form_LED_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        ' LED OFF then close dialog
        SysSetLED(LED_OFF, 0, 0, 0)
        button_Off_Click(sender, e)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()

    End Sub
End Class