'***************************************************************************
'* <Description>
'* Form_Vibrator.vb (Casio Computer Co., Ltd.)
'* -------------------------------------------------------------------------
'* <Function outline>
'* System Library Demo program
'* -------------------------------------------------------------------------
'* <Language>
'* VB.NET
'* -------------------------------------------------------------------------
'* <Develop Environment>
'* VS 2005
'* -------------------------------------------------------------------------
'* <Target>
'* DT-5300 WM / IT-800 WM / IT-300 model
'* -------------------------------------------------------------------------
'* Copyright(C)2010 CASIO COMPUTER CO.,LTD. All rights reserved.
'* -------------------------------------------------------------------------
'* <History>
'* Version  Date            Company     Keyword     Comment
'* 1.0.0    2010.02.16      CASIO       000000      Original      
'* 
'***************************************************************************/

Imports Calib.SystemLibNet.Def
Imports Calib.SystemLibNet.Api

Public Class Form_Vibrator


    Private Const dwTypeNum As Int32 = 6
    Private dwTypeList(dwTypeNum) As Int32
    Private OldSetting(dwTypeNum) As Boolean

    Private Sub button_Play_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Play.Click
        Dim dwRet As Int32
        Dim nSelType As Int32
        Dim dwNum As Int32 = 0
        Dim dwOnTime As Int32 = 0
        Dim dwOffTime As Int32 = 0

        nSelType = comboBox_Type.SelectedIndex
        If (dwTypeList(nSelType) = B_USERDEF) Then
            ' get count
            dwNum = Convert.ToInt32(textBox_Num.Text)

            ' get vibration on time
            dwOnTime = Convert.ToInt32(textBox_OnTime.Text)

            ' get vibration off time
            dwOffTime = Convert.ToInt32(textBox_OffTime.Text)
        End If

        ' Play
        dwRet = SysPlayVibrator(dwTypeList(nSelType), dwNum, dwOnTime, dwOffTime)
        ShowErrorMessage("SysPlayVibrator", dwRet)
    End Sub

    Private Sub button_Stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_Stop.Click
        ' Stop
        SysStopVibrator()
    End Sub

    Private Sub Form_Vibrator_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' vibration type combobox initialize
        comboBox_Type.Items.Add("Alarm")
        dwTypeList(0) = B_ALARM

        comboBox_Type.Items.Add("Warning")
        dwTypeList(1) = B_WARNING

        comboBox_Type.Items.Add("Scanner")
        dwTypeList(2) = B_SCANEND

        comboBox_Type.Items.Add("Wireless read")
        dwTypeList(3) = B_WIREREAD

        comboBox_Type.Items.Add("User Define")
        dwTypeList(4) = B_USERDEF

        comboBox_Type.Items.Add("All Vibrator")
        dwTypeList(5) = B_ALL

        ' get vibration setting
        GetVibratorSetting()

        comboBox_Type.SelectedIndex = 0
    End Sub

    Private Sub GetVibratorSetting()
        Dim dwMute As Int32
        Dim i As Int32

        For i = 0 To dwTypeNum
            ' get mute setting
            dwMute = SysGetVibratorMute(dwTypeList(i))
            ShowErrorMessage("SysGetVibratorMute", dwMute)
            If (dwMute <> 0) Then
                OldSetting(i) = True
            Else
                OldSetting(i) = False
            End If
        Next
    End Sub

    Private Sub comboBox_Type_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_Type.SelectedIndexChanged
        Dim nSelType As Int32 = comboBox_Type.SelectedIndex

        ' get mute setting
        If (SysGetVibratorMute(dwTypeList(nSelType)) <> 0) Then
            checkBox_Mute.Checked = True
        Else
            checkBox_Mute.Checked = False
        End If

        ' judge selected vibration type is user setting or not
        If (dwTypeList(nSelType) = B_USERDEF) Then
            ' vibration count
            textBox_Num.Text = "2"
            textBox_Num.Enabled = True

            ' vibration on time
            textBox_OnTime.Text = "100"
            textBox_OnTime.Enabled = True

            ' vibration off time
            textBox_OffTime.Text = "100"
            textBox_OffTime.Enabled = True

        Else
            ' disable vibration count
            textBox_Num.Text = ""
            textBox_Num.Enabled = False

            ' disable vibration on time
            textBox_OnTime.Text = ""
            textBox_OnTime.Enabled = False

            ' disable vibration off time
            textBox_OffTime.Text = ""
            textBox_OffTime.Enabled = False
        End If

        ' judge selected vibration type is full vibration or not
        If (dwTypeList(nSelType) = B_ALL) Then
            button_Play.Enabled = False
        Else
            button_Play.Enabled = True
        End If
    End Sub

    Private Sub checkBox_Mute_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox_Mute.CheckStateChanged
        Dim dwRet As Int32
        Dim nSelType As Int32 = comboBox_Type.SelectedIndex


        ' change mute setting
        dwRet = SysSetVibratorMute(dwTypeList(nSelType), checkBox_Mute.Checked)
        ShowErrorMessage("SysSetVibratorMute", dwRet)
    End Sub

    Private Sub Form_Vibrator_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Dim dwRet As Int32
        Dim i As Int32

        ' return before setting
        For i = 0 To dwTypeNum

            ' change vibration setting
            dwRet = SysSetVibratorMute(dwTypeList(i), OldSetting(i))
            ShowErrorMessage("SysGetVibratorMute", dwRet)
        Next
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()

    End Sub
End Class