/***************************************************************************
 * <Description>
 * SystemLibSampleVC.cpp (Casio Computer Co., Ltd.)
 * -------------------------------------------------------------------------
 * <Function outline>
 * System Library Demo program
 * -------------------------------------------------------------------------
 * <Language>
 * Visual C++
 * -------------------------------------------------------------------------
 * <Develop Environment>
 * VS 2005
 * -------------------------------------------------------------------------
 * <Target>
 * DT-5300 WM / IT-800 WM model
 * -------------------------------------------------------------------------
 * Copyright(C)2009 CASIO COMPUTER CO.,LTD. All rights reserved.
 * -------------------------------------------------------------------------
 * <History>
 * Version  Date            Company     Keyword     Comment
 * 1.0.0    2010.04.28      CASIO       000000      Original      
 * 
 ***************************************************************************/
//	000000__	Original
//	__000000	Original

#include <windows.h>
#include "resource.h"
#include <aygshell.h>

//	000000__	Original
//  CASIO Libaray
#include "SystemLib.h"
//	__000000	Original

#define MAX_LOADSTRING 100
HINSTANCE				hInst;			// current instance

BOOL DlgMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
//BOOL NFC_Scan(HWND hDlg);
//BOOL DispErrorMessage(HWND hDlg, int iRet);
extern LRESULT CALLBACK	LedDlgProc			(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK	BuzzerDlgProc		(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK VibratorDlgProc		(HWND, UINT, WPARAM, LPARAM);

int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPWSTR lpCmdLine, int nShowCmd)
{
	hInst = hInstance;
	DialogBoxW(hInstance, MAKEINTRESOURCE( IDD_MAIN ), NULL, DlgMain);
	return 0;
}

BOOL DlgMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			RECT rc;
			#define MENU_HEIGHT 26

            // Create a Done button and size it.  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_SIPDOWN | SHIDIF_FULLSCREENNOMENUBAR ;
            shidi.hDlg = hDlg;
            SHInitDialog(&shidi);
				
			GetWindowRect(hDlg, &rc);
			MoveWindow(hDlg, rc.left, rc.top, rc.right, rc.bottom+MENU_HEIGHT, TRUE);

			SetForegroundWindow(hDlg);
			SHFullScreen(hDlg, SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);	

			HMENU hMenu;

			hMenu = LoadMenu(  hInst, MAKEINTRESOURCE(IDR_MENU1));

			SHMENUBARINFO mbi = {0};
			mbi.cbSize = sizeof(SHMENUBARINFO);
			mbi.hwndParent = hDlg;
			mbi.dwFlags = SHCMBF_HMENU;
			mbi.nToolBarId = (UINT)hMenu;
			mbi.hInstRes =  hInst;

			if (!SHCreateMenuBar(&mbi)){
				MessageBox(hDlg,L"failed", L"Error",MB_OK | MB_ICONERROR);
			}



		}
		//ShowWindow(GetDlgItem( hDlg, IDC_IC_CARD), SW_HIDE);
        return (INT_PTR)TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_EXIT:
			EndDialog(hDlg, LOWORD(wParam));
			break;
		case IDM_LED:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_LED), hDlg, (DLGPROC)LedDlgProc);
			break;
		case IDM_BUZZER:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_BUZZER), hDlg, (DLGPROC)BuzzerDlgProc);
			break;
		case IDM_VIBRATOR:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_VIBRATOR), hDlg, (DLGPROC)VibratorDlgProc);
			break;

		//case IDC_NFC_SCAN:
		//	NFC_Scan(hDlg);
		//	break;
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hDlg);
		break;
	}
	return FALSE;
}

// error message display
void ShowErrorMessage(HWND hWnd, LPCTSTR pszCaption, DWORD dwStatus)
{
	TCHAR szTitle[MAX_LOADSTRING];
	TCHAR szMsg[MAX_LOADSTRING];
	UINT idError;

	// message box caption
	if(pszCaption && wcslen(pszCaption))
	{
		wcscpy(szTitle, pszCaption);
	}
	else
	{
		LoadString(hInst, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	}

	//error message
	if(dwStatus == SYS_PARAMERR)			idError = IDS_ERR_PARAMETER;
	else if(dwStatus == FUNCTION_UNSUPPORT)	idError = IDS_ERR_UNSUPPORT;
	else									return;

	// message box display
	LoadString(hInst, idError, szMsg, MAX_LOADSTRING);
	MessageBox(hWnd, szMsg, szTitle, MB_OK | MB_ICONSTOP);
}
