/****************************************************************************
 *
 *      Project     : GPRS_tutorial
 *      File        : gprs_tutorial.cpp
 *      Description : this code is  tutorial that use WAN GPRS connection.
 *
 *      Copyright (C) 2009 CASIO COMPUTER CO.,LTD.
 *              !!!!! CASIO CONFIDENTIAL !!!!!
 *	<History>
 *	Version	Date		Name			Keyword		Comment
 *						
 *****************************************************************************/

#include "stdafx.h"
#include "WANGPRSLibSampleVC.h"
#include <windows.h>
#include <commctrl.h>
#include "WANGPRSLib.h"

#ifdef WIN32_PLATFORM_PSPC	// Windows Mobile
#include "delete_connection_manager_entry.h"
#endif

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE		g_hInst;							// current instance
HWND			g_hEdit;

HRASCONN		g_hRasConn=0;						//!< RAS handle
const char*		g_szPIN_CODE="1111";				//!< PIN code for SIM
LPCWSTR			g_RasEntryNameW=TEXT("WANG_GPRS");	//!< RAS entry name to make (UNICODE)
const char*		g_RasEntryName="WANG_GPRS";			//!< RAS entry name to make (char)
const char*		g_GPRS_APN="anritsu.ne.jp";			//!< APN (Network Provider)

//! buffer for displaying
LPCTSTR str_bool[2]={TEXT("false"),TEXT("success")};
	
//
//! If your network provider requests to specify UserName and Password, please set these.
//LPCTSRT g_RasUserName=TEXT("gprs");			//!< Username for network provider
//LPCTSRT g_RasPassword=TEXT("gprs");			//!< Password for network provider

//! DEFINES 
#define CONVIDandSTR(IDNAME) { IDNAME, TEXT(#IDNAME) }
#define CONVIDandSTR2(IDNAME,STR) { IDNAME, STR }
#define BOOLTOSTRING(BVAL) str_bool[( (BVAL==true)?1:0) ]


// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
void			StartTest(void);
void			EditBoxAddText(LPCTSTR lpText);

// ! PROTOTYPE FUNCTION
////sub routines
bool turnOn_WANmodule();	//!< 
bool unlock_PINLOCK();		//!< Unlock SIM Pin
bool create_RASENTRY();		//!< 
bool connect_GPRS();		//!< RAS connection
bool notify_message();		//!< 
bool disconnect_GPRS();		//!< RAS disconnection
bool turnOff_WANmodule();	//!< 
//// utility
LPCTSTR WANGPRS_ERROR_IDtoString(DWORD idWAN_GPRS_ERROR);	//!< error displaying


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_GPRS_TUTORIALVC));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_GPRS_TUTORIALVC));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable
#ifdef WIN32_PLATFORM_PSPC	// Windows Mobile
    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();
#endif
    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_GPRS_TUTORIALVC, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);


    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 	DWORD dwStyle, dwExStyle;

    switch (message) 
    {
         case WM_CREATE:
#ifdef WIN32_PLATFORM_PSPC
			SHINITDLGINFO shidi;

			shidi.hDlg = hWnd;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_EMPTYMENU;	
			SHInitDialog(&shidi);
#endif
 			// Create out put edit box.
			dwExStyle = WS_EX_WINDOWEDGE;
			dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | ES_MULTILINE | ES_READONLY;
			// DT-X30
//			g_hEdit = CreateWindowEx(dwExStyle, L"EDIT", L"", dwStyle, 10, 20, 220, 240, hWnd, NULL, g_hInst, NULL);
			// DT-5300 IT-800
			g_hEdit = CreateWindowEx(dwExStyle, L"EDIT", L"", dwStyle, 10, 20, 440, 480, hWnd, NULL, g_hInst, NULL);
			
			SetTimer(hWnd, 1, 500, NULL);
            break;

        case WM_DESTROY:
            PostQuitMessage(0);
            break;

		case WM_TIMER:
			KillTimer(hWnd, 1);
			StartTest();
			break;
#ifdef WIN32_PLATFORM_PSPC
		case WM_SIZE:
			if(wParam == SIZE_MINIMIZED)
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
#endif
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

void StartTest(void)
{										//
										// COMMUNICATION WITH GPRS
										//
	if(turnOn_WANmodule()==false){		// Power on GPRS module 
		goto error;						//
	}									//
	if(unlock_PINLOCK()==false){		// Unlock SIM Pin
		goto error;						//
	}									//
	if(create_RASENTRY()==false){		// Make RAS entry
		goto error;						//
	}									//
	if(connect_GPRS()==false){			// RAS connection
		goto error;						//
	}									//
	if(notify_message()==false){		// Display a message
		goto error;						//
	}									//
	if(disconnect_GPRS()==false){		// Disconnection
		goto error;						//
	}									//
error:									//
	turnOff_WANmodule();				// Power off GPRS module
										//
										//
										// Exit
}

/*! Power On GPRS module

*/
bool turnOn_WANmodule()
{
	bool bRet;
	DWORD dwRet;
	TCHAR lpOutputString[256];

	EditBoxAddText(_T("INFO:turnOn_WANmodule Enter.\r\n"));

	//! To turn on the GPRS module, use this function.
	if((dwRet=WANSetPowerStatus(WAN_MODULE_POWER_ON))!=WAN_ERROR_SUCCESS){
		EditBoxAddText(_T("ERR:WANSetPowerStatus(ON)\r\n"));
		wsprintf( lpOutputString, _T("   err=%s(%d)\r\n"),WANGPRS_ERROR_IDtoString(dwRet),dwRet);
		EditBoxAddText(lpOutputString);
		bRet=false;
	}
	else {
		EditBoxAddText(_T("INFO:WANSetPowerStatus(ON) Success.\r\n"));
		bRet=true;
	}
	
	wsprintf(lpOutputString, _T("INFO:turnOn_WANmodule Leave(%s).\r\n\r\n"),BOOLTOSTRING(bRet));
	EditBoxAddText(lpOutputString);

	return bRet;
}


/*! If your SIM card is locked by PIN code, you must unlock it.
	If you don't, you cannot communicate.
*/
bool unlock_PINLOCK()
{
	bool bRet=false;
	DWORD dwRet;
	TCHAR lpOutputString[256];
	
	//Functions
	HANDLE hSIM=0;
	DWORD dwLockState;

	EditBoxAddText(_T("INFO:unlock_PINLOCK Enter.\r\n"));

	
	//! Before operating SIM related functions, you should get a handle. 
	if((dwRet=WANSIMInitialize(&hSIM) )!=WAN_ERROR_SUCCESS){
		EditBoxAddText(_T("ERR:WANSIMInitialize\r\n"));
		wsprintf(lpOutputString, _T("    error=%s(%d)\r\n"),WANGPRS_ERROR_IDtoString(dwRet),dwRet);
		EditBoxAddText(lpOutputString);
		bRet=false;
		goto error;
	}


	//! Checking the SIM status (Locked or not)
	if( (dwRet=WANSIMGetPhoneLockedState(hSIM,&dwLockState))!=WAN_ERROR_SUCCESS){
		EditBoxAddText(_T("ERR:WANSIMGetPhoneLockedState\r\n"));
		wsprintf(lpOutputString, _T("    error=%s(%d)\r\n"),WANGPRS_ERROR_IDtoString(dwRet),dwRet);
		EditBoxAddText(lpOutputString);
		bRet=false;
		goto error;
	}

	/*! If the status is WAN_SIM_LOCKSTATE_PIN, unlocking the PIN lock
	*/
	if(dwLockState==WAN_SIM_LOCKSTATE_PIN){	
		/*! Set right PIN code to g_szPIN_CODE and call WANSIMUnLockPhone.
		*/
		if( (dwRet=WANSIMUnLockPhone(hSIM,(BYTE*)g_szPIN_CODE,NULL)) !=WAN_ERROR_SUCCESS){
			/*! Faild to unlock. You should check if the PIN code is right.
			*/
			EditBoxAddText(_T("ERR:WANSIMUnLockPhone\r\n"));
			wsprintf(lpOutputString, _T("    error=%s(%d)\r\n"),WANGPRS_ERROR_IDtoString(dwRet),dwRet);
			EditBoxAddText(lpOutputString);
			bRet=false;	
		}
		else {
			//! Unlocked
			bRet=true;
		}
	}
	/*!  If the status is WAN_SIM_LOCKSTATE_READY, already unlocked or no SIM sucurity.
	*/
	else  if(dwLockState==WAN_SIM_LOCKSTATE_READY){
		
		return true;

	}

	/*! In other case, you can't use your SIM with DT-X30. Please access your SIM supplier.
	*/
	else {
		//!ERROR -> other locks..
		EditBoxAddText(_T("ERR:Security Error.\r\n"));
		bRet=false;
		goto error;
	}

error:



	/*!  You should Deinit the Handle after using SIM function.
	*/
	if(hSIM){
		if( (dwRet=WANSIMDeInitialize(hSIM))!=WAN_ERROR_SUCCESS){
			EditBoxAddText(_T("ERR:WANSIMDeInitialize\r\n"));
			wsprintf(lpOutputString, _T("    error=%s(%d)\r\n"),WANGPRS_ERROR_IDtoString(dwRet),dwRet);
			EditBoxAddText(lpOutputString);
		}
	}

	wsprintf(lpOutputString, _T("INFO:unlock_PINLOCK Leave(%s).\r\n\r\n"),BOOLTOSTRING(bRet));
	EditBoxAddText(lpOutputString);

	return bRet;
}


/*! Making RAS entry
	@retval true	Success
			false	Fail
*/
bool create_RASENTRY()
{
	bool bRet=false;
	DWORD dwRet;
	TCHAR lpOutputString[256];

	EditBoxAddText(_T("INFO:create_RASENTRY Enter.\r\n"));

	// check if the named RAS entry already exist or not
	EditBoxAddText(_T("INFO:RAS Entry Checking \r\n"));
	if( (dwRet=RasValidateEntryName(NULL, g_RasEntryNameW)) != 0){
		if(dwRet==ERROR_ALREADY_EXISTS){
			/*! If it already exists, delete it. (This is only for sample. 
			  If you use existing entry, you can use it.)
			*/
			EditBoxAddText(_T("INFO:RAS Entry already exist!.\r\n"));
			EditBoxAddText(_T("     Trying to delete this entry..\r\n"));
			
#ifdef WIN32_PLATFORM_PSPC	// Windows Mobile
			if( delete_connection_manager_entry( (wchar_t*)g_RasEntryNameW )==false){
				EditBoxAddText(_T("ERR:RAS Entry delete Fail\r\n"));
				wprintf(lpOutputString, _T("    (RasDeleteEntry)err=%d..\r\n"),dwRet);
				EditBoxAddText(lpOutputString);
				goto error;
			}
#else						// Windows CE
			if( (dwRet=RasDeleteEntry(NULL,(LPWSTR)g_RasEntryNameW))!=0){
				EditBoxAddText(_T("ERR:RAS Entry delete Fail\r\n"));
				wsprintf(lpOutputString, _T("    (RasDeleteEntry)err=%d..\r\n"),dwRet);
				EditBoxAddText(lpOutputString);
				goto error;
			}
#endif
			//! success to delete existing entry
			else {
				EditBoxAddText(_T("INFO:RAS Entry delete OK\r\n"));
			}
		}
		//! your specified entry name is not accepted by MS RAS functions
		else if(dwRet==ERROR_INVALID_NAME){
			EditBoxAddText(_T("ERR:RAS Entry Invalid\r\n"));
			EditBoxAddText(_T("   it has been unexpected..\r\n"));
			goto error;		
		}
	}
	else {
		//! your specified entry name is not existing
		EditBoxAddText(_T("INFO:NO EXISTING RAS Entry.\r\n"));
	}



	//! make RAS entry
	if((dwRet=WANSetRASSetting((BYTE*)g_RasEntryName,NULL,(BYTE*)g_GPRS_APN))!=WAN_ERROR_SUCCESS){
		EditBoxAddText(_T("ERR:RAS Entry can't create!\r\n"));
		wsprintf(lpOutputString, _T("    (RasDeleteEntry)err=%d..\r\n"),dwRet);
		EditBoxAddText(lpOutputString);
		goto error;
	}


	//SUCCESS
	bRet=true;

error:

	wsprintf(lpOutputString, _T("INFO:create_RASENTRY Leave(%s).\r\n\r\n"),BOOLTOSTRING(bRet));
	EditBoxAddText(lpOutputString);

	return bRet;

}


/*! RAS Connection

*/
bool connect_GPRS()
{
	bool bRet = false;
	DWORD dwRet;
	DWORD dwRASResult;
	TCHAR lpOutputString[256];

	RASDIALPARAMS rasDialParam;
	
	EditBoxAddText(_T("INFO:connect_GPRS Enter.\r\n"));
	
	
	memset(&rasDialParam,0,sizeof(RASDIALPARAMS));

	//! set the member of RASDIALPARAMS

	rasDialParam.dwSize=sizeof(RASDIALPARAMS);
	//! copy RAS entry name (UNICODE)
	wcscpy(rasDialParam.szEntryName,g_RasEntryNameW);

	//! If your network provider requests to specify UserName and Password, please set these.
	//!< User name for RAS connection
	//wcscpy_s(rasDialParam.szUserName,sizeof(rasDialParam.szUserName),g_RasUserName);
	//!< Password for RAS connection
	//wcscpy_s(rasDialParam.szPassword,sizeof(rasDialParam.szPassword),g_RasPassword);


	//! Do RAS Conncetion
	EditBoxAddText(_T("INFO:WANRASConnect \r\n"));
	EditBoxAddText(_T("     Connecting\r\n"));

	if( (dwRet=WANRASConnect(&dwRASResult,&rasDialParam,NULL,0, &g_hRasConn))==WAN_ERROR_SUCCESS){

		if(dwRASResult!=ERROR_SUCCESS){
			//! RasDial() fails. WANRASConnect() calls MS's RasDial().
			EditBoxAddText(_T("ERR:WANRASConnect Fail\r\n"));
			wsprintf(lpOutputString, _T("   RASRESULT=%d\r\n"),dwRASResult);
			EditBoxAddText(lpOutputString);
			bRet=false;
			goto error;
		}
		else {
			//! Success
			EditBoxAddText(_T("INFO:WANRASConnect Connected\r\n"));
		}
	}
	else {
		//! WANRASConnect fails. Please check the return code to find the reason.
		EditBoxAddText(_T("ERR:WANRASConnect \r\n"));
		wsprintf(lpOutputString, _T("    Fail WANerr=%s(%d) \r\n"),WANGPRS_ERROR_IDtoString(dwRet),dwRet);
		EditBoxAddText(lpOutputString);
		bRet=false;
		goto error;
	}


	//! Success
	bRet=true;

error:

	wsprintf(lpOutputString, _T("INFO:connect_GPRS Leave(%s).\r\n\r\n"),BOOLTOSTRING(bRet));
	EditBoxAddText(lpOutputString);

	return bRet;
}


/*!
	Display the messagebox

*/
bool notify_message()
{	
	bool bRet=true;
	int iRet;
	while( ( iRet=MessageBox(NULL,_T("Disconnect???"),_T("INFO"),MB_OK))!=IDOK){
		if(iRet==0){
			//MessageBox failure...
			bRet=false;
		}
		Sleep(1000);
	}
	return bRet;
}


/*! Disconnect the RAS connection
*/
bool disconnect_GPRS()
{
	DWORD dwRet;
	bool bRet;
	DWORD dwRASResult;
	TCHAR lpOutputString[256];

	EditBoxAddText(_T("INFO:disconnect_GPRS Enter.\r\n"));

	if( (dwRet=WANRASDisConnect(&dwRASResult,g_hRasConn))==WAN_ERROR_SUCCESS){
		if(dwRASResult!=ERROR_SUCCESS){
			//! RasHangUp() fails. WANRASDisConnect() calls MS's RasHangUp().
			EditBoxAddText( _T("ERR:WANRASDisConnect Fail \r\n"));
			wsprintf(lpOutputString, _T("    RASRESULT=%d\r\n"), dwRASResult);
			EditBoxAddText(lpOutputString);
			bRet=false;
		}
		else {
			//! SUCCESS
			g_hRasConn=0;
			bRet=true;
		}
	}
	else {
		EditBoxAddText(_T("ERR:WANRASDisConnect Fail \r\n"));
		wsprintf(lpOutputString, _T("    WANerr=%s(%d)\r\n"), WANGPRS_ERROR_IDtoString(dwRet), dwRet);
		EditBoxAddText(lpOutputString);
		bRet=false;
	}

	wsprintf(lpOutputString, _T("INFO:disconnect_GPRS Leave(%s).\r\n\r\n"),BOOLTOSTRING(bRet));
	EditBoxAddText(lpOutputString);

	return bRet;
}


/*!
	Power off the GPRS module
*/
bool turnOff_WANmodule()
{
	bool bRet;
	DWORD dwRet;
	TCHAR lpOutputString[256];

	EditBoxAddText(_T("INFO:turnOff_WANmodule Enter.\r\n"));

	//Power off the GPRS module
	if((dwRet=WANSetPowerStatus(WAN_MODULE_POWER_OFF))!=WAN_ERROR_SUCCESS){
		EditBoxAddText(_T("ERR:WANSetPowerStatus(OFF) \r\n"));
		wsprintf(lpOutputString, _T("    err=%d\r\n"), dwRet);
		EditBoxAddText(lpOutputString);
		bRet=false;
		goto error;
	}
	else {
		//! SUCCESS
		bRet=true;
	}
error:
	wsprintf(lpOutputString, _T("INFO:turnOff_WANmodule Leave(%s).\r\n"),BOOLTOSTRING(bRet));
	EditBoxAddText(lpOutputString);

	return bRet;
}


/*! Convert error code to string
	@param DWORD idWAN_GPRS_ERROR@error code
	@retval LPCTSRT TEXT("...") 
			LPCTSRT TEXT("Unknown ID")
	@detail
		Note: The returning pointer is pointed to the static strings.
		Do not write to this pointer block.
*/
LPCTSTR WANGPRS_ERROR_IDtoString(DWORD idWAN_GPRS_ERROR)
{
	static struct {
		DWORD dwID;
		LPCTSTR name;
	} _tbl_WANGPRS_ERROR_ID[]={

		CONVIDandSTR(WAN_ERROR_SUCCESS),
		CONVIDandSTR(WAN_BUFFER_ERROR),		
		CONVIDandSTR(WAN_ERROR_BADPARAM	),
		CONVIDandSTR(WAN_ERROR_BUFFER_ERROR	),
		CONVIDandSTR(WAN_ERROR_BUSY	),
		CONVIDandSTR(WAN_ERROR_FAIL),
		CONVIDandSTR(WAN_ERROR_ILLEGAL_HANDLE),
		CONVIDandSTR(WAN_ERROR_INCORRECT_PASSWORD),
		CONVIDandSTR(WAN_ERROR_MODULE_NOT_READY),
		CONVIDandSTR(WAN_ERROR_MORE_OPERATOR),
		CONVIDandSTR(WAN_ERROR_NOMAIL),
		CONVIDandSTR(WAN_ERROR_NOSIM)		,
		CONVIDandSTR(WAN_ERROR_OPERATION_NOT_ALLOW),
		CONVIDandSTR(WAN_ERROR_NO_OPERATOR),
		CONVIDandSTR(WAN_ERROR_NETWORK_NOT_AVAILABLE),

		CONVIDandSTR(WAN_ERROR_NOT_IMPLEMENT),
		CONVIDandSTR2(0xFFFFFFFF,TEXT("Unknown ID") )
	};

	DWORD i=0;
	while(_tbl_WANGPRS_ERROR_ID[i].dwID!=0xFFFFFFFF){
		if(_tbl_WANGPRS_ERROR_ID[i].dwID==idWAN_GPRS_ERROR){
			break;
		}
		++i;
	}
	return _tbl_WANGPRS_ERROR_ID[i].name;
}

void EditBoxAddText(LPCTSTR lpText)
{
	int nLastPos = GetWindowTextLength(g_hEdit);
    
    // Add Text
	SendMessage(g_hEdit, EM_SETSEL, nLastPos, nLastPos);
	SendMessage(g_hEdit, EM_REPLACESEL, FALSE, (LPARAM)lpText);
	
	SendMessage(g_hEdit, EM_SCROLLCARET, 0, 0);
	SetFocus(g_hEdit);
}

#ifdef WIN32_PLATFORM_PSPC	// Windows Mobile
/* Delete Connection Manager Entry
	@retval true	Success
			false	Fail
*/
bool delete_connection_manager_entry(wchar_t* w_szEntryName)
{
	//!ProvXML
	wchar_t* provXMLBuffer=0;
	//DMProcessConfigXML
	LPWSTR pszOutputXML=0;
	HRESULT hr=0;
	// Check parameter
	if(w_szEntryName == NULL){
		return false;
	}
	DWORD	n;
	bool	bRet=true;
	struct XML_setting_info		*pXML_setting[1]={ XML_delete1 };
	for(n=0;n<XML_SETTING_INFO_NUMBER;++n){
		// Create buffer memorys
		if( (provXMLBuffer=(WCHAR *) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,MAX_PROV_LENGTH*sizeof(WCHAR) ))==NULL){
			bRet=false;
			break;
		}
		if(createPROVXML(provXMLBuffer,MAX_PROV_LENGTH*sizeof(wchar_t) , pXML_setting[n],
						w_szEntryName)==false){
			bRet=false;
			break;
		 }		
		if( (hr = DMProcessConfigXML(provXMLBuffer,CFGFLAG_PROCESS,&pszOutputXML))!=S_OK ){
			delete[] pszOutputXML;
			bRet=false;
			break;
		}
		delete[] pszOutputXML;		
		if(provXMLBuffer){
		 	HeapFree(GetProcessHeap(), 0, provXMLBuffer);
			provXMLBuffer=0;
		}
	}
	if(provXMLBuffer){
		HeapFree(GetProcessHeap(), 0, provXMLBuffer);
		provXMLBuffer=0;
	}    	
	return bRet;
}



//!
static bool createPROVXML(wchar_t* pOut,unsigned long dwLength,struct XML_setting_info *setting,
					wchar_t* entry_name)
{
	DWORD dwOffset=0;
	DWORD cnt=0;
	DWORD dwType;
	wchar_t* tmp_line=0;
	
	if( (tmp_line=(wchar_t *) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,MAX_LINE_LENGTH*sizeof(wchar_t) ))==NULL){		
		goto err;
	}

	struct XML_setting_info	*cur_line=setting;	
	while( (dwType=cur_line->line_arg_type)!=XML_SETTING_ARG_TAIL){
		wcscpy(tmp_line,TEXT(""));
		switch (dwType){
			case XML_SETTING_ARG_NONE:
				swprintf(tmp_line,cur_line->lines);
				break;
			case XML_SETTING_ARG_ENTRYNAME:
				swprintf(tmp_line,cur_line->lines,entry_name);
				break;

		default:;
		}
		//!
		dwOffset+=wcslen(tmp_line);
		if(dwOffset>=dwLength)goto err;
		//!
		wcscat(pOut,tmp_line);
		++cur_line;	
	}
	if(tmp_line){
	 	HeapFree(GetProcessHeap(), 0, tmp_line);
	}    
	return true;
err:
	if(tmp_line){
	 	HeapFree(GetProcessHeap(), 0, tmp_line);
	}
	return false;
}
#endif
